-- espio sprite2 animations
local espio = chaotix.espio

-- wait animation
local function espio_resetWait(mo)
	mo.espio_wait_transition = nil
	mo.espio_wait_leveltime = nil
end

espio.WaitAnimation = function(p)
	local mo = p.mo
	
	if (mo.state == S_PLAY_NIGHTS_STAND)
		mo.sprite2 = SPR2_WAIT
	end
	if (mo.sprite2 != SPR2_WAIT) then espio_resetWait(mo) return end
	
	-- set frame
	if (mo.espio_wait_transition == nil)	-- just started wait?
	or (mo.espio_wait_transition)	-- still transitioning
		-- handle transition timer
		if (mo.espio_wait_transition == nil) then mo.espio_wait_transition = 4 end
		mo.espio_wait_transition = $-1
		
		-- transition frame, stay on frame A
		chaotix.SetFrame(mo, A)
	else
		if (mo.espio_wait_leveltime == nil) then mo.espio_wait_leveltime = leveltime end	-- so the animation always starts from the first frame
		local waittime = leveltime - mo.espio_wait_leveltime
	
		local frames = {B, C, D, E, B, C, D, E, F, G, H, I, J, K, L, I, J, K, L, I, J, M, N, O}
		local tics = 5
		
		chaotix.SetFrame(mo, frames[((waittime % (#frames * tics)) / tics) + 1])
	end
end

-- teeter animation
local function espio_resetTeeter(mo)
	mo.espio_teeter_frame = nil
	mo.espio_teeter_tics = nil
end

espio.TeeterAnimation = function(p)
	local mo = p.mo
	
	if (mo.sprite2 != SPR2_EDGE) then espio_resetTeeter(mo) return end
	
	-- set frame
	if not (mo.espio_teeter_tics)
		mo.espio_teeter_frame = ($ != nil) and $+1 or 0
		mo.espio_teeter_tics = 3 * (not (mo.espio_teeter_frame%2) and 5 or 1)
	end
	mo.espio_teeter_tics = $-1
	
	local frames = {0, 1, 2, 1}
	chaotix.SetFrame(mo, frames[(mo.espio_teeter_frame % #frames) + 1])
end

espio.Animations = function(p)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	if (mo.skin != espio.SKIN) then espio_resetWait(mo) return end
	
	espio.WaitAnimation(p)
	espio.TeeterAnimation(p)
end