-- espio's ceiling cling
local espio = chaotix.espio

-- F_SKY1 checking fucking
local function espio_SkyCheck(p, flipcond)
	local mo = p.mo
	local rover = (flipcond) and mo.floorrover or mo.ceilingrover

	if (rover and rover.valid)
		local pic = (flipcond) and "toppic" or "bottompic"
		
		return rover[pic]:upper():find("F_SKY")
	else
		local sec = mo.subsector.sector
		local pic = (flipcond) and "floorpic" or "ceilingpic"
		
		return sec[pic]:upper():find("F_SKY")
	end
end

-- FOF checking function
local function espio_FOFCheck(p)
	local mo = p.mo

	-- get the FOF, if we dont have one, then why are we even here?
	local rover = (mo.eflags & MFE_VERTICALFLIP) and mo.floorrover or mo.ceilingrover
	if not (rover and rover.valid) then return true end
	
	-- we don't need to check this
	if not (rover.flags & FF_EXISTS) then return true end
	if not (rover.flags & FF_BLOCKPLAYER or rover.flags & FF_QUICKSAND) then return true end
	
	-- it's a mario block that we need to hit
	if (rover.flags & FF_MARIO) then return false end
	if (rover.flags & FF_QUICKSAND) then return false end
	
	-- if we're here, it must be clean
	return true
end

espio.CeilingCling = function(p)
	local mo = p.mo
	
	if p.espio_flipcam and not (mo and mo.valid and mo.espio_ceilingCling)
		p.espio_flipcam = 0
		p.pflags = $ | PF_FLIPCAM
	end
	
	if not (mo and mo.valid) then return end
	
	if not (espio.AbilityCheck(p))
		if (mo.espio_ceilingCling)
			mo.espio_ceilingCling = nil
			mo.flags2 = not ($ & MF2_OBJECTFLIP) and $|(MF2_OBJECTFLIP) or $ & ~(MF2_OBJECTFLIP)
			mo.eflags = not ($ & MFE_VERTICALFLIP) and $|(MFE_VERTICALFLIP) or $ & ~(MFE_VERTICALFLIP)
		end
		
		return 
	end
	
	-- stasis check (for stuff like hide & seek)
	local stasischeck = false
	if ((gametyperules & GTR_TAG) and (gametyperules & GTR_HIDEFROZEN))
		local hidetime = CV_FindVar("hidetime").value
		
		-- if we're hiding, we shouldnt have to hold jump anymore!
		if (leveltime >= (hidetime*TICRATE))	-- no longer hiding
		and not (p.pflags & PF_TAGIT)	-- we're not the seeker
			stasischeck = true
		end
	end
	stasischeck = $ or (p.pflags & PF_JUMPSTASIS)	-- fallback on any potential PF_JUMPSTASIS's I guess
	
	if (mo.espio_ceilingCling)	-- we HAVE clinged
		-- fall off conditions
		if not (P_IsObjectOnGround(mo))	-- we're no longer on the ceiling!
		or (mo.espio_ceilingCling != P_MobjFlip(mo))	-- we flipped while we were flipped, flip us back to what we should be flipped to!
		or (mo.tracer and (mo.tracer.type == MT_TUBEWAYPOINT))	-- we're in a zoomtube, put us back
		or (not (p.cmd.buttons & BT_JUMP) and not stasischeck)	-- we're not holding jump anymore (unless in full stasis)
		or (p.gotflag or p.gotcrystal)	-- we have the ctf flag (or the battlemod crystal), no cheesing!
		or (espio_SkyCheck(p, mo.espio_ceilingCling == 1))	-- we somehow got our way to the sky
		or (CBW_Battle and p.exhaustmeter == 0)	-- we're exhaused (battle mod)
			mo.espio_ceilingCling = nil
			mo.flags2 = not ($ & MF2_OBJECTFLIP) and $|(MF2_OBJECTFLIP) or $ & ~(MF2_OBJECTFLIP)
			mo.eflags = not ($ & MFE_VERTICALFLIP) and $|(MFE_VERTICALFLIP) or $ & ~(MFE_VERTICALFLIP)
			
			-- dont set state while being controlled
			local stateValid = (mo.state >= S_PLAY_STND and mo.state <= S_PLAY_DASH)
			
			if (not P_IsObjectOnGround(mo) and stateValid)
			and not (mo.tracer)
			and not (p.pflags & PF_SPINNING)
				p.pflags = $|(PF_JUMPED) & ~(PF_THOKKED)
				mo.state = S_PLAY_ROLL
				mo.momz = -1 * P_MobjFlip(mo)
			end
			
			S_StartSound(mo, sfx_kc45)
			return
		end
		
		-- instantly go to waiting while clinged
		if (mo.state == S_PLAY_STND) then mo.state = S_PLAY_WAIT end
	else	-- we WANT to cling
		-- conditions we cant cling under
		if (mo.eflags & MFE_GOOWATER)	-- not under goop
		or (P_InQuicksand(mo)) -- not in quicksand
		or (p.gotflag or p.gotcrystal)	-- not while we have the flag (or the battlemod crystal)
		or (CBW_Battle and p.exhaustmeter == 0)	-- we're exhaused (battle mod)
			return
		end
		
		-- wall run forward check
		local forward
		if (twodlevel or (mo.flags2 & MF2_TWOD))	-- fuck
			forward = (p.cmd.sidemove > 0 and mo.angle == 0 or p.cmd.sidemove < 0 and mo.angle == ANGLE_180)
		else
			forward = p.cmd.forwardmove > 0
		end
			
		if ((p.pflags & PF_JUMPED) and p.cmd.buttons & BT_JUMP)	-- jumping while holding jump
		or (p.climbing)	-- running up the wall
			local checkz = mo.z + mo.height
			local checksurface = P_CeilingzAtPos(mo.x, mo.y, mo.z, mo.height)
			if (mo.eflags & MFE_VERTICALFLIP)
				checkz = mo.z
				checksurface = P_FloorzAtPos(mo.x, mo.y, mo.z, mo.height)
			end
			
			-- momz check
			local momzcheck = false
			if ((mo.eflags & MFE_VERTICALFLIP) and mo.momz < 0)
			or (not (mo.eflags & MFE_VERTICALFLIP) and mo.momz > 0)
				momzcheck = true
			end
			
			-- check if we can cling!
			if (abs(checkz - checksurface) < FixedMul(mo.scale, espio.CeilingClingRange))
			and (not espio_SkyCheck(p, mo.eflags & MFE_VERTICALFLIP))
			and (espio_FOFCheck(p))
			and (momzcheck)
				-- let's flip!
				mo.flags2 = not ($ & MF2_OBJECTFLIP) and $|(MF2_OBJECTFLIP) or $ & ~(MF2_OBJECTFLIP)
				mo.eflags = not ($ & MFE_VERTICALFLIP) and $|(MFE_VERTICALFLIP) or $ & ~(MFE_VERTICALFLIP)
				mo.espio_ceilingCling = P_MobjFlip(mo)
				if p.pflags & PF_FLIPCAM and mo.espio_ceilingCling == -1
					p.espio_flipcam = mo.espio_ceilingCling
					p.pflags = $ &~ PF_FLIPCAM
				end
				
				-- safety nets
				P_SetOrigin(mo, mo.x, mo.y, checksurface - ((mo.eflags & MFE_VERTICALFLIP) and mo.height or 0))
				mo.momz = FixedMul(mo.scale, -1*P_MobjFlip(mo))
				mo.state = S_PLAY_RUN
				mo.espio_colourshift_delay = 2
				
				-- wallrun stuff
				if (p.climbing)
					p.climbing = 0
					p.pflags = $ & ~(PF_JUMPED)
					
					-- get a bit of momentum if holding forward
					mo.angle = $ + ANGLE_180
					p.drawangle = mo.angle
					if (forward) then P_InstaThrust(mo, mo.angle, FixedMul(mo.scale, mo.espio_wallrun_lastmomz)) end
					
					p.charability = CA_ESPIOREAL
					espio.resetWallRun(p)
				end
				
				S_StartSound(mo, sfx_kc45)
			end
		end
	end
end