-- espio's SRB2Persona support
if not (srb2p) then return end
local espio = chaotix.espio

-- god this needed to be defined separately
local stand_bored = {SPR_PLAY,
-- incoming mustard gas
A, A, A, A,	-- transition start
B, B, B, B, B,	-- wait before turning
C, C, C,	-- turn right
D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D, D,	-- wait looking right
C, C, C, B, B, B, E, E, E,	-- turn left
F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, -- wait looking left
F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, F, -- wait looking left
E, E, E, B, B, B,	-- return to neutral
A, A, A, A,	-- transition end
1, "SPR2_WAIT"}

-- espio's stats
charStats[espio.SKIN] = {
	-- general info
	name = "Espio",		-- This is only for bots / enemies
	basehp = 42,			-- base HP for level 1 (Cannot be <= 0)
	basesp = 48,			-- base SP for level 1 (Can be 0, but not < 0!)
	persona = "espio_jiraiya",		-- Persona to use
	melee_natk = "espio_atk",	-- normal melee attack
	
	-- weapon
	wep = "espio_shoes",
	weptype = WPT_SHOES,

	-- attack attributes
	atk = 28,	--- attack power of physical attacks
	acc = 90,	-- accuracy of physical attacks
	crit = 6,

	-- anims
	anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
	anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
	anim_stand_bored =	stand_bored,	-- standing (rare anim)
	anim_guard = 		{SPR_PLAY, A, 1, "SPR2_WALK"},		-- guarding
	anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_WALK"},		-- moving
	anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
	anim_atk =			{SPR_PLAY, A, B, C, D, E, F, 1, "SPR2_ROLL"},	-- attacking
	anim_aoa_end =		{SPR_PLAY, D, C, B, 1, "SPR2_TWIN"},	-- jumping out of all-out attack
	anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},		-- taking damage
	anim_getdown =		{SPR_PLAY, A, 1, "SPR2_PAIN"},		-- knocked down from weakness / crit
	anim_downloop =		{SPR_PLAY, A, 1, "SPR2_SHIT"},		-- is down
	anim_getup =		{SPR_PLAY, A, 4, "SPR2_WAIT"},		-- gets up from down
	anim_death =		{SPR_PLAY, A, 30, "SPR2_PAIN"},		-- dies
	anim_revive =		{SPR_PLAY, A, B, C, D, 1, "SPR2_TWIN"},		-- gets revived
	
	anim_evoker =	{SPR_PLAY, A, 2, "SPR2_TAL0"},	-- holding evoker to head
	anim_evoker_shoot =	{SPR_PLAY, A, 2, "SPR2_TAL0"},		-- shooting evoker
	
	anim_special1 = {SPR_PLAY, A, B, 4, "SPR2_WAIT"}, -- get on the ground
	anim_special2 = {SPR_PLAY, A, B, 2, "SPR2_FALL"}, -- falling

	-- voice lines
	vfx_summon = {"sfx_essum1", "sfx_essum2", "sfx_essum3", "sfx_essum4"},	-- Summoning Persona to use a Skill
	vfx_skill = {"sfx_esskl1"},		-- Used a Skill
	vfx_item = {"sfx_esaor1"},		-- Used an item
	vfx_hurt = {"sfx_eshrt1", "sfx_esmis2"},		-- Sustained damage
	vfx_hurtx = {"sfx_eshrx1", "sfx_eshrx2"},		-- Sustained heavy damage / Critical hit / Weakness
	vfx_die = {"sfx_esdie1"},		-- Death
	vfx_heal = {"sfx_esdge1"},		-- Healed by teammate
	vfx_healself = {"sfx_esdge1"},	-- Healed self
	vfx_kill = {"sfx_eskll1", "sfx_eskll2"},		-- Killed an enemy
	vfx_1more = {"sfx_es1mr1", "sfx_es1mr2"},		-- Performed 1more
	vfx_crit = {"sfx_escrt1", "sfx_escrt2", "sfx_escrt3"},		-- Cut-in for Weakness/Critical Hit
	vfx_aoaask = {"sfx_esaoi1", "sfx_esaoi2"},	-- Ask to All-Out Attack
	vfx_aoado = {"sfx_esaoa1", "sfx_esaoa2"},		-- Performing All-Out Attack
	vfx_aoarelent = {"sfx_esaor1"},	-- Relenting from All-Out Attack
	vfx_miss = {"sfx_esmis1", "sfx_esmis2", "sfx_esmis3"},		-- Missed attack
	vfx_dodge = {"sfx_esdge1"},		-- Dodged enemy attack
	vfx_win = {"sfx_eswin1", "sfx_eswin2", "sfx_eswin3"},		-- Battle won
	vfx_levelup = {"sfx_eslvl1"},	-- Level Up!

	-- hud definitions
	icon = "ICO_EPIO",			-- head icon for character select
	hudbust = "ESPIO_H",			-- patch to draw on the stat hud
	hudaoa = "H_ESPAOA",		-- patch for all out attack hud
	aoa_quote = "Focus your minds...\nprepare to strike!",
	hudcutin = "ESPIO_A",		-- cut in frames prefix

	-- CSS tip
	tip = "Learns Wind, Psychic and evasive skills.\nHe has pitifully low HP and defence,\nbut makes up for it with his agility\nand evasion, making him have a heavy\nrisk-reward playstyle. Try to avoid\nenemy advantages at all costs!",
}
VFX_freeslotC(espio.SKIN)

-- espio's persona, jiraiya!
chaotix.SafeFreeslot("SPR_PJRA")
personaList["espio_jiraiya"] = {
	-- general
	name = "Jiraiya",	-- Name of the Persona
	arcana = ARCANA_MAGICIAN,			-- Arcana (unused in Beta 1.0.0, can be left nil as well)
	
	-- debug info
	sprite = SPR_PJRA,
	startframe = 0,

	-- anims
	anim_idle = 	{SPR_PJRA, A, B, C, B, 8},	-- Idle animation when summoned in the menu
	anim_atk = 		{SPR_PJRA, D, E, F, G, H, I, J, K, L, M, N, O, O, O, P, Q, R, S, S, S, S, 2},	-- Animation when attacking

	-- stats
	strength = 7,
	magic = 11,
	endurance = 5,
	luck = 9,
	agility = 12,

	-- affinities
	weak = ATK_ELEC|ATK_NUCLEAR,
	resist = ATK_WIND|ATK_PSY,
	
	-- skills
	skills = {
				{"garu", 1}, {"sukukaja", 1},
				{"psi", 12}, {"sukunda", 14},
				{"magaru", 17}, {"garula", 22},
				{"keen eye", 25},	-- espio's keen unique skill
				
				{"psio", 30, "psi"},
				{"magarula", 34, "garu"},
				{"masukukaja", 38, "sukukaja"},
				{"invigorate 1", 41, "magaru"},
				{"masukunda", 44, "sukunda"},
				
				{"mind charge", 47},
				{"garudyne", 52, "garula"},
				{"invigorate 2", 57, "invigorate 1"},
				{"psiodyne", 61, "psio"},
				
				{"opulence", 63, "keen eye"},
				{"magarudyne", 65, "magarula"},
				{"invigorate 3", 69, "invigorate 2"},
			},
}

-- Espio's normal attack, stealth strike
local function espio_fadeOverTime(mo, fadetimer, time)
	local fade = fadetimer*10/time
	
	-- reset these
	mo.frame = ($ & ~FF_TRANSMASK)
	mo.flags2 = $ & ~(MF2_DONTDRAW)
				
	-- set transparency or drawing flags
	if (fade >= 1 and fade <= 9)
		mo.frame = ($ & ~FF_TRANSMASK) | (fade << FF_TRANSSHIFT)
	elseif (fade == 10)	-- max fade, hide us completely
		mo.flags2 = $|(MF2_DONTDRAW)
	end
	//print("fadetimer: "..fadetimer)
	//print("fade: "..fade)
end

attackDefs["espio_atk"] = {
	name = "Stealth Strike",
	type = ATK_STRIKE,
	power = 35,
	accuracy = 95,
	critical = 10,
	target = TGT_ENEMY,
	cost = CST_HP,
	cost = 0,
	desc = "A stealthy strike that\ncatches enemies off guard.",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	anim = 	function(mo, targets, hittargets, timer)
				local target = targets[1]
				local atarget = hittargets[1]
				
				local APPEARTIME = TICRATE*6/5
				local ATTACKTIME = 13
				local FINISHTIME = TICRATE
				if (timer <= 8)
					if (timer == 1)
						ANIM_set(mo, mo.anim_special1, false)

						-- set the camera
						local cx = target.x + 384*cos(target.angle + ANG1*20)
						local cy = target.y + 384*sin(target.angle + ANG1*20)
						local cz = target.z + FRACUNIT*64
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, cz, 24*FRACUNIT)
						CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
					end
					
					-- fade out
					espio_fadeOverTime(mo, timer, 8)
				elseif (timer == APPEARTIME)
					-- remove flags from the fading out
					mo.frame = ($ & ~FF_TRANSMASK)
					mo.flags2 = $ & ~(MF2_DONTDRAW)
	
					-- teleport near target
					local tpdestdistance = 264
					local tpdestangle = target.angle + ANGLE_180 + (P_RandomRange(-69, 69)*ANG1)
					local tpdestx = target.x + (tpdestdistance*cos(tpdestangle))
					local tpdesty = target.y + (tpdestdistance*sin(tpdestangle))
					P_TeleportMove(mo, tpdestx, tpdesty, target.z + FRACUNIT*72)
					
					-- launch to the target
					ANIM_set(mo, mo.anim_atk, true)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					P_InstaThrust(mo, mo.angle, 19*FRACUNIT)
					P_SetObjectMomZ(mo, -2*FRACUNIT)
					S_StartSound(mo, sfx_zoom)
					
					-- dont just appear out of nowhere, appear from smoke!
					for i = 1, 16
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height/2), MT_DUMMY)
						dust.state = S_AOADUST1
						dust.frame = A|FF_FULLBRIGHT
						dust.scale = FRACUNIT*3
						dust.destscale = FRACUNIT/12
						
						-- give it some momentum
						local mom = 8
						dust.momx = P_RandomRange(-mom, mom)*FRACUNIT
						dust.momz = P_RandomRange(-mom, mom)*FRACUNIT
						dust.momy = P_RandomRange(-mom, mom)*FRACUNIT
					end
				elseif (timer == (APPEARTIME + ATTACKTIME))
					-- change momentum a bit on the impact
					P_InstaThrust(mo, mo.angle, 4*FRACUNIT)
					P_SetObjectMomZ(mo, 11*FRACUNIT)
					
					damageObject(atarget)
					P_StartQuake(FRACUNIT*7, 4)
					playSound(mo.battlen, sfx_phys)
					for i = 1, 2 do createSplat(mo) end
				elseif (timer == (APPEARTIME + ATTACKTIME + FINISHTIME - 7))
					ANIM_set(mo, mo.anim_special2, true)
				elseif (timer == (APPEARTIME + ATTACKTIME + FINISHTIME))
					return true
				end
			end,
	critanim = 	function(mo, targets, hittargets, timer)
				local target = targets[1]
				local atarget = hittargets[1]
				
				local APPEARTIMES = {TICRATE*6/5, TICRATE*6/5 + 21, TICRATE*6/5 + 50}
				if (timer <= 8)
					if (timer == 1)
						mo.espio_attackdirection = P_RandomRange(0, 1) and true or false
						ANIM_set(mo, mo.anim_special1, false)

						-- set the camera
						local cx = target.x + 384*cos(target.angle + ANG1*20)
						local cy = target.y + 384*sin(target.angle + ANG1*20)
						local cz = target.z + FRACUNIT*64
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, cz, 24*FRACUNIT)
						CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
					end
					
					-- fade out
					espio_fadeOverTime(mo, timer, 8)
				-- first apperance
				elseif (timer == APPEARTIMES[1])
					-- remove flags from the fading out
					mo.frame = ($ & ~FF_TRANSMASK)
					mo.flags2 = $ & ~(MF2_DONTDRAW)
	
					-- teleport near target
					local angle = P_RandomRange(-63, -33)
					if (mo.espio_attackdirection) then angle = $*-1 end
					angle = $*ANG1
					
					local tpdestdistance = 272
					local tpdestangle = target.angle + ANGLE_180 + angle
					local tpdestx = target.x + (tpdestdistance*cos(tpdestangle))
					local tpdesty = target.y + (tpdestdistance*sin(tpdestangle))
					P_TeleportMove(mo, tpdestx, tpdesty, target.z + FRACUNIT*80)
					mo.espio_attackdirection = not $
					
					-- launch to the target
					ANIM_set(mo, mo.anim_atk, true)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					P_InstaThrust(mo, mo.angle, 25*FRACUNIT)
					P_SetObjectMomZ(mo, -6*FRACUNIT)
					S_StartSound(mo, sfx_zoom)
					
					-- dont just appear out of nowhere, appear from smoke!
					for i = 1, 16
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height/2), MT_DUMMY)
						dust.state = S_AOADUST1
						dust.frame = A|FF_FULLBRIGHT
						dust.scale = FRACUNIT*3
						dust.destscale = FRACUNIT/12
						
						-- give it some momentum
						local mom = 8
						dust.momx = P_RandomRange(-mom, mom)*FRACUNIT
						dust.momz = P_RandomRange(-mom, mom)*FRACUNIT
						dust.momy = P_RandomRange(-mom, mom)*FRACUNIT
					end
				elseif (timer == (APPEARTIMES[1] + 9))
					mo.momz = -mo.momz
					P_StartQuake(FRACUNIT*7, 4)
					playSound(mo.battlen, sfx_phys)
					createSplat(mo)
				elseif (timer >= (APPEARTIMES[1] + 14) and timer <= (APPEARTIMES[1] + 19))
					local fadetimer = timer - (APPEARTIMES[1] + 14)
					espio_fadeOverTime(mo, fadetimer, 19 - 14)
				-- 2nd appearance
				elseif (timer == APPEARTIMES[2])
					-- remove flags from the fading out
					mo.frame = ($ & ~FF_TRANSMASK)
					mo.flags2 = $ & ~(MF2_DONTDRAW)
	
					-- teleport near target
					local angle = P_RandomRange(-43, -22)
					if (mo.espio_attackdirection) then angle = $*-1 end
					angle = $*ANG1
					
					local tpdestdistance = 288
					local tpdestangle = target.angle + ANGLE_180 + angle
					local tpdestx = target.x + (tpdestdistance*cos(tpdestangle))
					local tpdesty = target.y + (tpdestdistance*sin(tpdestangle))
					P_TeleportMove(mo, tpdestx, tpdesty, target.z + FRACUNIT*96)
					
					-- launch to the target
					ANIM_set(mo, mo.anim_atk, true)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					P_InstaThrust(mo, mo.angle, 29*FRACUNIT)
					P_SetObjectMomZ(mo, -6*FRACUNIT)
					S_StartSound(mo, sfx_zoom)
					
					-- dont just appear out of nowhere, appear from smoke!
					for i = 1, 16
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height/2), MT_DUMMY)
						dust.state = S_AOADUST1
						dust.frame = A|FF_FULLBRIGHT
						dust.scale = FRACUNIT*3
						dust.destscale = FRACUNIT/12
						
						-- give it some momentum
						local mom = 8
						dust.momx = P_RandomRange(-mom, mom)*FRACUNIT
						dust.momz = P_RandomRange(-mom, mom)*FRACUNIT
						dust.momy = P_RandomRange(-mom, mom)*FRACUNIT
					end
				elseif (timer == (APPEARTIMES[2] + 9))
					mo.momz = -mo.momz
				
					P_StartQuake(FRACUNIT*8, 4)
					playSound(mo.battlen, sfx_phys)
					for i = 1, 2 do createSplat(mo) end
				elseif (timer >= (APPEARTIMES[2] + 14) and timer <= (APPEARTIMES[2] + 19))
					local fadetimer = timer - (APPEARTIMES[2] + 14)
					espio_fadeOverTime(mo, fadetimer, 19 - 14)
				-- final appearance, the one that deals damage
				elseif (timer == APPEARTIMES[3])
					-- remove flags from the fading out
					mo.frame = ($ & ~FF_TRANSMASK)
					mo.flags2 = $ & ~(MF2_DONTDRAW)
	
					-- teleport near target
					local angle = P_RandomRange(-19, 19)*ANG1
					
					local tpdestdistance = 128
					local tpdestangle = target.angle + ANGLE_180 + angle
					local tpdestx = target.x + (tpdestdistance*cos(tpdestangle))
					local tpdesty = target.y + (tpdestdistance*sin(tpdestangle))
					P_TeleportMove(mo, tpdestx, tpdesty, target.z + FRACUNIT*192)
					
					-- launch to the target
					ANIM_set(mo, mo.anim_atk, true)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					P_InstaThrust(mo, mo.angle, 12*FRACUNIT)
					P_SetObjectMomZ(mo, -20*FRACUNIT)
					S_StartSound(mo, sfx_zoom)
					
					-- dont just appear out of nowhere, appear from smoke!
					for i = 1, 16
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height/2), MT_DUMMY)
						dust.state = S_AOADUST1
						dust.frame = A|FF_FULLBRIGHT
						dust.scale = FRACUNIT*3
						dust.destscale = FRACUNIT/12
						
						-- give it some momentum
						local mom = 8
						dust.momx = P_RandomRange(-mom, mom)*FRACUNIT
						dust.momz = P_RandomRange(-mom, mom)*FRACUNIT
						dust.momy = P_RandomRange(-mom, mom)*FRACUNIT
					end
				elseif (timer == (APPEARTIMES[3] + 9))
					-- change momentum a bit on the final impact
					P_InstaThrust(mo, mo.angle, 5*FRACUNIT)
					P_SetObjectMomZ(mo, 13*FRACUNIT)
					
					damageObject(atarget)
					P_StartQuake(FRACUNIT*12, 7)
					playSound(mo.battlen, sfx_phys)
					for i = 1, 2 do createSplat(mo) end
				elseif (timer == (APPEARTIMES[3] + TICRATE*3/2 - 13))
					ANIM_set(mo, mo.anim_special2, true)
				elseif (timer == (APPEARTIMES[3] + TICRATE*3/2))
					return true
				end
			end,
}
-- testing crit anims
//enemyList["maya_1"].weak = ATK_SLASH|ATK_STRIKE|ATK_PIERCE|ATK_FIRE|ATK_ICE|ATK_WIND|ATK_ELEC|ATK_PSY|ATK_NUCLEAR|ATK_CURSE|ATK_BLESS
//DNG_waves[1] = {{"maya_1", "balance_1", "maya_1"}}

-- Define Keen Eye, a weaker version of Opulence for Espio's playstyle
attackDefs["keen eye"] = {
	name = "Keen Eye",
	type = ATK_PASSIVE|ATK_SLASH|ATK_STRIKE|ATK_PIERCE|ATK_FIRE|ATK_ICE|ATK_WIND|ATK_ELEC|ATK_PSY|ATK_NUCLEAR|ATK_CURSE|ATK_BLESS,
	desc = "Boost evasion rate\nagainst all attacks by 8%",
	power = 8,
	passive = PSV_DODGE,
}
-- (Redefine this, doesn't exist as of now)
attackDefs["opulence"] = {
	name = "Opulence",
	type = ATK_PASSIVE|ATK_SLASH|ATK_STRIKE|ATK_PIERCE|ATK_FIRE|ATK_ICE|ATK_WIND|ATK_ELEC|ATK_PSY|ATK_NUCLEAR|ATK_CURSE|ATK_BLESS,
	desc = "Boost evasion rate\nagainst all attacks by 25%",
	power = 25,
	passive = PSV_DODGE,
}

-- Espio's starting weapon
weaponsList["espio_shoes"] = {
	name = "Clinger Sneakers",
	type = WPT_SHOES,
	atk = 270,
	desc = "Sneakers that have a\nvery tight grip.",
	slot = "mastery 1",
	rarity = 1,
}