-- mighty's definitions
chaotix.mighty = {}
local mighty = chaotix.mighty
mighty.SKIN = "mighty"
chaotix.AddCharacter(mighty)

-- mighty's sounds
local hijack_sounds = {
	{sound = "sfx_kc55", caption = "Cling"},
}
for k, v in pairs(hijack_sounds)
	-- these are now mighty's sounds
	sfxinfo[_G[v.sound]].caption = v.caption
end

local new_sounds = {
	{sound = "sfx_hamdrp", caption = "Dropping"},
	{sound = "sfx_hamlnd", caption = "Powerful impact"},
	{sound = "sfx_hamspk", caption = "METEOR SMASH"},
	{sound = "sfx_spkprt", caption = "Spike protection"},
	{sound = "sfx_vnboom", caption = "Vine boom"},
	{sound = "sfx_mcharg", caption = "Charging"},
	{sound = "sfx_plunch", caption = "Launch"},
}
for k, v in pairs(new_sounds)
	chaotix.SafeFreeslot(v.sound)
	sfxinfo[_G[v.sound]].caption = v.caption
end

-- mighty's skincolour's
chaotix.SafeFreeslot("SKINCOLOR_ROSE")
skincolors[SKINCOLOR_ROSE] = {
	name = "Rose",
	ramp = {32,33,34,37,38,39,40,41,42,43,44,45,46,46,47,47},
	invcolor = skincolors[SKINCOLOR_RED].invcolor,
	invshade = 9,
	chatcolor = V_REDMAP,
	accessible = true
}
M_MoveColorAfter(SKINCOLOR_ROSE, SKINCOLOR_RED)

chaotix.SafeFreeslot("SKINCOLOR_BBQ")
skincolors[SKINCOLOR_BBQ] = {
	name = "BBQ",
	ramp = {209, 211, 212, 213, 213, 214, 215, 60, 61, 44, 45, 46, 47, 47, 47, 31},
	invcolor = SKINCOLOR_TEAL,
	invshade = 5,
	chatcolor = V_REDMAP,
	accessible = true
}
M_MoveColorAfter(SKINCOLOR_BBQ, SKINCOLOR_CRIMSON)

chaotix.SafeFreeslot("SKINCOLOR_MIGHTYOUTLINE")
skincolors[SKINCOLOR_MIGHTYOUTLINE] = {
	name = "Mighty Outline",
	ramp = {170, 172, 167, 169, 169, 253, 253, 139, 139, 254, 254, 29, 29, 30, 31, 31},
	invcolor = SKINCOLOR_FOREST,
	invshade = 5,
	chatcolor = V_PURPLEMAP,
	accessible = false
}

-- super rose
chaotix.SafeFreeslot("SKINCOLOR_SUPERROSE1")
skincolors[SKINCOLOR_SUPERROSE1] = {
	name = "Super Rose 1",
	ramp = {208, 208, 209, 210, 32, 32, 34, 34, 36, 36, 38, 38, 39, 39, 40, 40},
	accessible = false
}
chaotix.SafeFreeslot("SKINCOLOR_SUPERROSE2")
skincolors[SKINCOLOR_SUPERROSE2] = {
	name = "Super Rose 2",
	ramp = {209, 209, 210, 32, 33, 33, 35, 35, 38, 38, 40, 40, 41, 41, 42, 42},
	accessible = false
}
chaotix.SafeFreeslot("SKINCOLOR_SUPERROSE3")
skincolors[SKINCOLOR_SUPERROSE3] = {
	name = "Super Rose 3",
	ramp = {210, 210, 32, 33, 35, 35, 37, 37, 40, 40, 42, 42, 43, 43, 44, 44},
	accessible = false
}
chaotix.SafeFreeslot("SKINCOLOR_SUPERROSE4")
skincolors[SKINCOLOR_SUPERROSE4] = {
	name = "Super Rose 4",
	ramp = {32, 32, 33, 34, 36, 36, 38, 38, 41, 41, 43, 43, 44, 44, 45, 45},
	accessible = false
}
chaotix.SafeFreeslot("SKINCOLOR_SUPERROSE5")
skincolors[SKINCOLOR_SUPERROSE5] = {
	name = "Super Rose 5",
	ramp = {32, 32, 34, 35, 37, 37, 39, 39, 42, 42, 44, 44, 45, 45, 46, 46},
	accessible = false
}

-- mighty's ability slot
rawset(_G, "CA_MIGHTY", 57)	-- ability name + number
mighty.AbilityCheck = function(p)
	local mo = p.mo
	
	-- man
	local abilitycheck = p.charability != CA_MIGHTY
	if (srb2p) and (mo and mo.valid) then abilitycheck = (mo.skin != mighty.SKIN) end
	
	if (abilitycheck and not p.mighty_wallkick)	-- we use CA_GLIDEANDCLIMB hacks for wall runs, so we need a buffer
		return false
	end
	
	-- we have espio's ability if we're here
	return true
end

-- wall kick constants
mighty.WallKickJumpSpeed = 17*FRACUNIT
mighty.WallKickJumpHeight = 15*FRACUNIT
mighty.WallKickJumpMaxAngle = 80
mighty.WallKickMomStabilizer = FRACUNIT*6/9
mighty.WallKickMomZFallingStabilizer = FRACUNIT/6
mighty.WallKickSlideTics = 4*TICRATE	-- how long you can stay clinged before you start sliding down
mighty.WallKickSlideModifier = FRACUNIT*94/100
mighty.WallKickMinXYSlide = FRACUNIT/2
mighty.WallKickSlideClingSpeed = FRACUNIT/3	-- while going up or clinging
mighty.WallKickSlideFallSpeed = FRACUNIT/7	-- when decending
mighty.WallKickDelay = TICRATE/5
mighty.WallKickDustTicBounds = {3, 12}
mighty.WallKickDustMomBounds = {FRACUNIT*3/4, 11*FRACUNIT}
mighty.WallKickSuperModifier = FRACUNIT*6/5	-- increased strength for super as a bonus
mighty.WallKickMinInfoSave = 2	-- the minimum amount of info needed to save a cling
mighty.WallKickMaxInfoSave = 3	-- the max amount of info that can be saved
mighty.WallKickMaxFrameTics = TICRATE/3
mighty.WallKickMaxFrameSpeed = FRACUNIT*12

-- hammer drop constants
mighty.HammerDropStartupTics = 3
mighty.HammerDropStartupModifier = FRACUNIT/2
mighty.HammerDropStartMomentum = -34*FRACUNIT
mighty.HammerDropSuperStartModifier = FRACUNIT*5/4
mighty.HammerDropBuildupMomentum = -(FRACUNIT*3/5)
mighty.HammerDropSuperBuildupModifier = FRACUNIT*5/2
mighty.HammerDropRecoilMomentum = 5*FRACUNIT
mighty.HammerDropGhostTics = 6
mighty.HammerDropSpringMultiplier = FRACUNIT*13/10
mighty.HammerDropSpringTwirlMultiplier = FRACUNIT*11/5
mighty.HammerDropDashMultiplier = FRACUNIT*7/6
mighty.HammerDropTotalDistModifier = FRACUNIT*37/5
mighty.HammerDropTotalDistSuperModifier = FRACUNIT*2
mighty.HammerDropDamageDistMultiplier = FRACUNIT*3/5
mighty.HammerDropSpikeDistMultiplier = FRACUNIT*2/5
mighty.HammerDropDustDistMultiplier = FRACUNIT*3/5
mighty.HammerDropFloorDistanceLeeway = FRACUNIT*8
mighty.HammerDropMetalStunTime = 3*TICRATE/2
mighty.HammerDropMetalStunShift = 6
mighty.HammerDropYStretch = FRACUNIT/96
mighty.HammerDropXStretch = FixedMul(-(FRACUNIT/3), mighty.HammerDropYStretch)
mighty.HammerDropQuakeIntensity = FRACUNIT*8
mighty.HammerDropQuakeTics = TICRATE/4

-- protection constants
mighty.SpikeSpeedThreshold = FRACUNIT/2	-- based on normalspeed, make sure it's LESS than FRACUNIT
mighty.ProtectionDefaultPushbackModifier = FRACUNIT*2/5
mighty.ProtectionThrustModifier = FRACUNIT/2
mighty.ProtectionGravityModifier = FRACUNIT*3/4

-- meme constants
mighty.ShellDeathChance = FRACUNIT/8
mighty.ShellDeathThreshold = -7*FRACUNIT
mighty.ShellDeathStall = 6
mighty.SexyTime = TICRATE
mighty.SexyStrength = 8*FRACUNIT
mighty.MighityChance = FRACUNIT/32

-- battlemod constants
mighty.HammerDropMomXYMultiplier = FRACUNIT/4
mighty.HammerDropTumbleHeight = 9*FRACUNIT
mighty.HammerDropTumbleTics = TICRATE*5/4
mighty.HammerDropSpikeBounces = 3
mighty.HammerDropSpikeModifier = FRACUNIT/6
mighty.PunchRingCost = 10
mighty.PunchCooldown = TICRATE*7/3
mighty.PunchChargeTics = TICRATE	-- how long it takes to get to max charge
mighty.PunchChargeReleaseTics = mighty.PunchChargeTics + (TICRATE/2)	-- how long until we're forced to release
mighty.PunchChargeWalkMultiplier = FRACUNIT/6
mighty.PunchThrustMomentumBounds = {FRACUNIT*24, FRACUNIT*38}	-- minimum and maximum  momentum bounds, depending on charge
mighty.PunchThrustTicBounds = {8, 15}	-- ^ ditto, but for tic duration
mighty.PunchThrustMaxRamp = FRACUNIT*4/3	-- it'll ramp up from FRACUNIT to this
mighty.PunchThrustZMultiplier = FRACUNIT*9/10	-- affect Z momentum
mighty.PunchHitKnockbackModifier = FRACUNIT	-- modifier for the knockback
mighty.PunchHitKnockbackHeight = 10*FRACUNIT
mighty.PunchHitTumbleTics = TICRATE*9/10
mighty.PunchHitStallTics = TICRATE/4
mighty.PunchHitTics = TICRATE*2/3
mighty.PunchHitSmearTics = {2, 2}
mighty.PunchCancelCooldown = TICRATE*9/5
mighty.PunchCancelHeight = FRACUNIT*9
mighty.PunchCancelMaxAngle = 45
mighty.PunchFlashMinFrequency, mighty.PunchFlashMaxFrequency = TICRATE/3, TICRATE/7
mighty.PunchFlashTics = TICRATE/5
mighty.PunchFlashMaxTrans = 6
mighty.PunchFlashColours = {
	SKINCOLOR_BLUE, SKINCOLOR_COBALT, SKINCOLOR_GALAXY, SKINCOLOR_PURPLE,
	SKINCOLOR_PHLOX, SKINCOLOR_NOBLE, SKINCOLOR_MAUVE, SKINCOLOR_RASPBERRY, SKINCOLOR_SANGRIA, SKINCOLOR_RED,
}
mighty.PunchMaxOffset = FRACUNIT*2
mighty.ShellTumbleTics = 24
mighty.ShellTumbleKnockback = 5*FRACUNIT/2
mighty.ShellTumbleZKnockback = 7*FRACUNIT

-- hammer drop states
chaotix.SafeFreeslot("S_MIGHTY_HAMMERDROP_STARTUP", "S_MIGHTY_HAMMERDROP") -- startup, drop
states[S_MIGHTY_HAMMERDROP_STARTUP] = {SPR_PLAY, A|SPR2_TAL1, mighty.HammerDropStartupTics, nil, 0, 0, S_MIGHTY_HAMMERDROP_STARTUP}
states[S_MIGHTY_HAMMERDROP] = {SPR_PLAY, A|SPR2_TAL2, 1, nil, 0, 0, S_MIGHTY_HAMMERDROP}

-- hammer drop spring state
chaotix.SafeFreeslot("S_MIGHTY_HAMMERDROP_SPRING")
states[S_MIGHTY_HAMMERDROP_SPRING] = {SPR_PLAY, A|SPR2_TAL3, 2, nil, 0, 0, S_MIGHTY_HAMMERDROP_SPRING}

A_MightyShell = function(mo)
	if not ((mo and mo.valid) and mo.health) then return end
	
	-- target validity checks
	local target = mo.target
	
	if not (target and target.valid)	-- target doesn't exist
	or (target.health)	-- they revived??
	or (target.skin != mighty.SKIN)	-- we are no longer mighty
		P_RemoveMobj(mo)
		return
	end
	
	-- adjust to target's colour
	mo.color = target.color
	mo.momz = $ - (43690 * P_MobjFlip(mo))	-- magic number for now until I find out the actual value for death falling
end
chaotix.SafeFreeslot("SPR_MSHL", "S_MIGHTY_SHELL")
states[S_MIGHTY_SHELL] = {SPR_MSHL, A, 1, A_MightyShell, 0, 0, S_MIGHTY_SHELL}

-- sexy
function A_Mighty_Sexy(actor, var1, var2)
	local p = actor.player
	if not (p and p.valid) then return end
	if (actor.skin != "mighty")
		actor.state = P_IsObjectOnGround(actor) and S_PLAY_STND or S_PLAY_FALL
		return
	end
	
	-- set panim
	p.panim = var1
	if (var1 == PA_FALL)
		-- gotta recreate this...
		local mintics = 1
		local speed = FixedDiv(abs(actor.momz), actor.scale)
		if (speed < 10<<FRACBITS)
			mintics = 4
		elseif (speed < 20<<FRACBITS)
			mintics = 3
		elseif (speed < 30<<FRACBITS)
			mintics = 2
		end
		
		if (actor.mighty_sexy_frametics == nil) then actor.mighty_sexy_frametics = mintics end
		actor.mighty_sexy_frametics = $ and min(mintics, $) or mintics
		
		-- set frame
		if (actor.mighty_sexy_frame == nil) then actor.mighty_sexy_frame = 0 end
		
		local numframes = 2
		actor.mighty_sexy_frametics = $-1
		if not (actor.mighty_sexy_frametics)
			actor.mighty_sexy_frame = $+1
					
			-- reset frame after max frame is reached
			if (actor.mighty_sexy_frame > (numframes - 1))
				actor.mighty_sexy_frame = 0
			end
		end
		chaotix.SetFrame(actor, actor.mighty_sexy_frame, SPR2_TAL5)
	end
	
	-- shake the screen!
	actor.mighty_sexy = $ and $-1
	local sexy = actor.mighty_sexy
	
	if (sexy)
	and (p == displayplayer or p == secondarydisplayplayer)	-- local shake
		local strength = (sexy * mighty.SexyStrength) / mighty.SexyTime
		P_StartQuake(strength, 1)
	end
end
chaotix.SafeFreeslot("S_MIGHTY_SEXY", "S_MIGHTY_SEXY_AIR")
states[S_MIGHTY_SEXY] = {SPR_PLAY, A|SPR2_TAL4, 1, A_Mighty_Sexy, PA_IDLE, 0, S_MIGHTY_SEXY}
states[S_MIGHTY_SEXY_AIR] = {SPR_PLAY, A|SPR2_TAL5, 1, A_Mighty_Sexy, PA_FALL, 0, S_MIGHTY_SEXY_AIR}

-- mighty's megaton punch
chaotix.SafeFreeslot("S_MIGHTY_PUNCH_CHARGE", "S_MIGHTY_PUNCH_THRUST", "S_MIGHTY_PUNCH_HIT")
states[S_MIGHTY_PUNCH_CHARGE] = {SPR_PLAY, SPR2_MLEE, -1, nil, 0, 0, S_MIGHTY_PUNCH_CHARGE}
states[S_MIGHTY_PUNCH_THRUST] = {SPR_PLAY, SPR2_TWIN, 2, nil, 0, 0, S_MIGHTY_PUNCH_THRUST}
states[S_MIGHTY_PUNCH_HIT] = {SPR_PLAY, SPR2_MLEL, -1, nil, 0, 0, S_MIGHTY_PUNCH_HIT}

-- dummy object to show deflected projectiles
chaotix.SafeFreeslot("MT_MIGHTY_PROJECTILE")
chaotix.AddHook("MobjThinker", function(projectile)
	-- flash
	if not (leveltime%2)
		projectile.flags2 = $|(MF2_DONTDRAW)
	else
		projectile.flags2 = $ & ~(MF2_DONTDRAW)
	end
	
	-- increase gravity
	local modifier = mighty.ProtectionGravityModifier
	projectile.momz = $ + (FixedMul(P_GetMobjGravity(projectile), modifier))
			
	-- despawn when landing
	if (projectile.eflags & MFE_JUSTHITFLOOR)
	or (P_IsObjectOnGround(projectile))
		P_RemoveMobj(projectile)
		return
	end
end, MT_MIGHTY_PROJECTILE)

chaotix.SafeFreeslot("MT_MIGHTY_HAMMERDROP")
mobjinfo[MT_MIGHTY_HAMMERDROP] = {
	spawnstate = S_INVISIBLE,
	seestate = S_TAILSOVERLAY_RUN,
	spawnhealth = 1000,
	radius = mobjinfo[MT_PLAYER].radius,
	height = mobjinfo[MT_PLAYER].height,
	dispoffset = 1,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
}
mighty.UpdateFollowMobj = function(p, fmo, reactiontime)
	local mo = p.mo
	
	//Visual copying
	fmo.skin = mo.skin
	fmo.scale = mo.scale
	fmo.radius = mo.radius
	fmo.height = mo.height
		
	fmo.rollangle = mo.rollangle
	fmo.mirrored = mo.mirrored
	fmo.spritexscale = FixedMul(FRACUNIT*3/4, mo.spritexscale)
	fmo.spriteyscale = FixedMul(FRACUNIT*6/5, mo.spriteyscale)
	fmo.spritexoffset = mo.spritexoffset
	fmo.spriteyoffset = mo.spriteyoffset
	fmo.renderflags = mo.renderflags | RF_FULLBRIGHT //| RF_NOCOLORMAPS
	fmo.blendmode = mo.blendmode
	fmo.flags2 = mo.flags2 & (MF2_DONTDRAW|MF2_SHADOW|MF2_SPLAT) | MF2_LINKDRAW
		
	//Set frame and state
	local state = fmo.info.seestate
			
	fmo.threshold = $ + 1
	if (fmo.state != state) then fmo.state = state end
	fmo.frame = (mo.frame &~ FF_FRAMEMASK) | ($ & FF_FRAMEMASK)
	if fmo.tics > 0 then fmo.tics = min($, 1) end
		
	//Set transparency
	local trans = min(max((10 - fmo.reactiontime) << FF_TRANSSHIFT, 0), FF_TRANS90)
	if (fmo.frame & FF_TRANSMASK) < trans
		fmo.frame = ($ &~ FF_TRANSMASK) | trans
	end
		
	//Set angle
	A_CapeChase(fmo, 1, 0)
end
chaotix.AddHook("FollowMobj", function(p, fmo)
	local mo = p.mo
		
	if fmo.reactiontime
		mighty.UpdateFollowMobj(p, fmo, fmo.reactiontime)
		
		-- reduce reaction time to fade out
		if (fmo.reactiondelay)
			fmo.reactiondelay = $-1
		else
			fmo.reactiontime = max(min($ - 3, 10), 0)
		end
		
		return true
	elseif fmo.state != fmo.info.spawnstate
		fmo.state = fmo.info.spawnstate
	end
end, MT_MIGHTY_HAMMERDROP)