-- I REALLY wanted to avoid this method
local mighty = chaotix.mighty

if not (mighty_protectionDefs)
	rawset(_G, "mighty_protectionDefs", {})
end
local defs = mighty_protectionDefs

-- function to get a field from the protection defs
mighty.GetProtectionDef = function(mobjtype, field)
	if not (defs[mobjtype]) then return end	-- no definition
	
	-- get the definition
	local def = defs[mobjtype]
	if not (def[field]) then return end	-- nothing defined here
	
	-- if we're here, there's something defined
	return def[field]
end

-- objects to blacklist completely
local blacklistObjects = {
	-- enemy projectiles
	MT_DETON, MT_DEMONFIRE,	-- tfw the deton is a projectile
	
	-- MF_PROJECTILE objects
	MT_SHOCKWAVE, 
	MT_FBOMB,
	MT_BLACKEGGMAN_GOOPFIRE, MT_BLACKEGGMAN_MISSILE,
	MT_CYBRAKDEMON_MISSILE, MT_CYBRAKDEMON_FLAMESHOT, 
	MT_CYBRAKDEMON_NAPALM_BOMB_LARGE, MT_CYBRAKDEMON_NAPALM_BOMB_SMALL, MT_CYBRAKDEMON_NAPALM_FLAMES,
	
	-- MF_PAIN objects
	MT_LASER,
	MT_CYBRAKDEMON_ELECTRIC_BARRIER,
	MT_ENERGYBALL,
	MT_GREENFLAME,
	MT_KOOPA,
	MT_SPINBOBERT_FIRE1, MT_SPINBOBERT_FIRE2,
}
for k, v in pairs(blacklistObjects)
	defs[v] = {blacklisted = true}
end

local function protection_painFunc(mo, inflictor, source)
	-- copypaste from mighty_protection.lua
	
	-- try not to reflect multiple times
	local rmo = mo.mighty_protection_reflectmo
	if ((rmo and rmo.valid) and rmo.health)	-- it still exists
	and (mo.mighty_protection_reflecttics)	-- still got tics left
	and (inflictor == rmo)	-- same mobj
		return false
	end
			
	local angle = R_PointToAngle2(mo.x, mo.y, inflictor.x, inflictor.y)
	P_InstaThrust(mo, angle, -(FixedHypot(mo.momx, mo.momy)))
	mo.momz = -(mo.momz)
			
	-- add their momentum if possible
	mo.momx = $ + (inflictor.momx)
	mo.momy = $ + (inflictor.momx)
	mo.momz = $ + (inflictor.momx)
			
	mo.mighty_protection_reflectmo = inflictor
	mo.mighty_protection_reflecttics = 5	-- dont get hit by the same inflictor till after this
	S_StartSound(mo, sfx_cdfm46)
	return false
end

-- specific definitions
defs[MT_CANNONBALL] = {pushback_modifier = FRACUNIT}	-- take FULL knockback from these
-- wallspike function (doesnt reflect properly right now, fix later?)
defs[MT_WALLSPIKE] = {
	func = function(mo, inflictor, source)
		if (mo.mighty_protection_sidetics)
			return false
		end
		
		-- get reflect angle
		local hitangle = inflictor.angle - R_PointToAngle2(0, 0, mo.momx, mo.momy)
		local reflectangle = inflictor.angle + hitangle
		
		-- reflect backwards
		local angle = R_PointToAngle2(mo.x, mo.y, inflictor.x, inflictor.y)
		P_InstaThrust(mo, reflectangle, -(FixedHypot(mo.momx, mo.momy)))
		S_StartSound(mo, sfx_cdfm46)
		return false
	end,
}
-- snappers
defs[MT_GSNAPPER] = {func = protection_painFunc}
defs[MT_SNAPPER_LEG] = {func = protection_painFunc}
defs[MT_SNAPPER_HEAD] = {func = protection_painFunc}