local charmy = chaotix.charmy

charmy.Coop = function(p)
	local mo = p.mo
	if not ((mo and mo.valid) and mo.health) then return end
	if (mo.skin != charmy.SKIN) then return end
	--carry other players!
	if (mo.state == S_PLAY_FALL or mo.state == S_CHARMY_ASCENT_CHARGE or mo.state == S_CHARMY_ASCENT or mo.state == S_CHARMY_STINGER_CHARGE or mo.state == S_CHARMY_STINGER)
		p.pflags = $|PF_CANCARRY
	else
		p.pflags = $ & ~PF_CANCARRY
	end
end
--use TIRE sprites when carrying another player
chaotix.AddHook("ThinkFrame", function()
	for p in players.iterate do
		local mo = p.mo
		if not ((mo and mo.valid) and mo.health) then return end
		if p.powers[pw_carry] == CR_PLAYER and mo.tracer and mo.tracer.valid
			if (mo.tracer.skin == charmy.SKIN) and (mo.tracer.state == S_PLAY_FALL)
				mo.tracer.sprite2 = SPR2_TIRE
			end
		end
	end
end)
--charmy bot stuff!
chaotix.AddHook("BotTiccmd", function(bot, cmd)
	local mo = bot.mo
	if not (mo and mo.valid) then return end
	if (mo.skin != charmy.SKIN)
		if (mo.charmy_indicator and mo.charmy_indicator.valid)
			P_RemoveMobj(mo.charmy_indicator)
		end
		return 
	end
	if not (bot.botleader and bot.botleader.valid) then return end
	--flight indicator!
	if (mo.charmy_indicator and mo.charmy_indicator.valid)
		local p = bot.botleader
		local dist = R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y) / mo.scale
		if (P_IsObjectOnGround(mo)) and (mo.state == S_PLAY_STND or mo.state == S_PLAY_WAIT) and (p.mo.state == S_PLAY_STND or p.mo.state == S_PLAY_WAIT) and dist < 26
			mo.charmy_indicator.state = S_FLIGHTINDICATOR
			mo.charmy_indicator.frame = leveltime%20 / 4
		else
			mo.charmy_indicator.state = S_INVISIBLE
		end
	else
		local indicator = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_OVERLAY)
		indicator.state = S_INVISIBLE
		indicator.target = mo
		indicator.spritexoffset = 5*FRACUNIT
		indicator.spriteyoffset = -14*FRACUNIT
		mo.charmy_indicator = indicator
	end
end)