-- charmy's definitions
chaotix.charmy = {}
local charmy = chaotix.charmy
charmy.SKIN = "charmy"
chaotix.AddCharacter(charmy)

-- charmy's skincolor, Bumble
chaotix.SafeFreeslot("SKINCOLOR_BUMBLE")
skincolors[SKINCOLOR_BUMBLE] = {
	name = "Bumble",
	ramp = {80, 82, 73, 74, 75, 76, 79, 21, 22, 23, 24, 26, 27, 28, 29, 30},
	invcolor = SKINCOLOR_BLUEBELL,
	invshade = 9,
	chatcolor = V_YELLOWMAP,
	accessible = true
}
M_MoveColorAfter(SKINCOLOR_BUMBLE, SKINCOLOR_YELLOW)
-- super bumble
chaotix.SafeFreeslot("SKINCOLOR_SUPERBUMBLE1")
skincolors[SKINCOLOR_SUPERBUMBLE1] = {
	name = "Super Bumble 1",
	ramp = {0, 0, 0, 0, 80, 82, 83, 4, 4, 4, 4, 6, 8, 10, 12, 14},
	accessible = false
}
chaotix.SafeFreeslot("SKINCOLOR_SUPERBUMBLE2")
skincolors[SKINCOLOR_SUPERBUMBLE2] = {
	name = "Super Bumble 2",
	ramp = {80, 80, 80, 82, 83, 72, 74, 16, 16, 16, 16, 16, 18, 20, 22, 24},
	accessible = false
}
chaotix.SafeFreeslot("SKINCOLOR_SUPERBUMBLE3")
skincolors[SKINCOLOR_SUPERBUMBLE3] = {
	name = "Super Bumble 3",
	ramp = {80, 80, 80, 83, 72, 73, 75, 18, 18, 18, 18, 18, 20, 22, 24, 26},
	accessible = false
}
chaotix.SafeFreeslot("SKINCOLOR_SUPERBUMBLE4")
skincolors[SKINCOLOR_SUPERBUMBLE4] = {
	name = "Super Bumble 4",
	ramp = {80, 81, 81, 72, 72, 74, 76, 21, 21, 21, 21, 21, 22, 24, 26, 28},
	accessible = false
}
chaotix.SafeFreeslot("SKINCOLOR_SUPERBUMBLE5")
skincolors[SKINCOLOR_SUPERBUMBLE5] = {
	name = "Super Bumble 5",
	ramp = {80, 82, 82, 73, 73, 75, 77, 22, 22, 22, 22, 22, 23, 25, 27, 29},
	accessible = false
}

-- charmy's sounds
local hijack_sounds = {
	{sound = "sfx_cdfm35", caption = "Launch"},
}
for k, v in pairs(hijack_sounds)
	-- these are now charmy's sounds
	sfxinfo[_G[v.sound]].caption = v.caption
end

local new_sounds = {
	{sound = "sfx_cchrg1", caption = "Accelerating"},
	{sound = "sfx_cchrg2", caption = "Accelerating"},
	{sound = "sfx_casnt1", caption = "Launch"},
	{sound = "sfx_casnt2", caption = "Launch"},
	{sound = "sfx_polm", caption = "Marked"},
}
for k, v in pairs(new_sounds)
	chaotix.SafeFreeslot(v.sound)
	sfxinfo[_G[v.sound]].caption = v.caption
end

-- charmy's abilities
local abilityslot = 23	-- guess what this is a reference to
rawset(_G, "CA_ASCENDANDFLY", abilityslot)
rawset(_G, "CA2_STINGER", abilityslot)
charmy.AbilityCheck = function(p, ability)
	-- since they're both the same number, we can do some fancy stuff!
	local checkability = (ability == 2) and "2" or ""
	return (p["charability"..checkability] == abilityslot)
end

-- knockback constants
charmy.KnockbackMultiplier = FRACUNIT*3/2

-- slow fall constants
charmy.SlowFallGravityModifier = FRACUNIT/2

-- quick ascent constants
charmy.QuickAscentCount = 3
charmy.QuickAscentChargeSounds = {sfx_s3k8e, sfx_cchrg1, sfx_cchrg2}	-- this won't function correctly if charmy.QuickAscentCount isn't 3, too bad!
charmy.QuickAscentChargeTics = TICRATE/2	-- how long it takes to get to max charge
charmy.QuickAscentChargeXYMultiplier = FRACUNIT*98/100	-- how much momentum is halted (XY)
charmy.QuickAscentChargeZMultiplier = FRACUNIT*3/4	-- how much momentum is halted (Z)
charmy.QuickAscentTicConversion = {1, FRACUNIT*9/10}	-- [1] tics every [2] of speed
charmy.QuickAscentThrustBounds = {FRACUNIT*16, FRACUNIT*23}	-- scales from [1] to [2] depending on charge
charmy.QuickAscentThrustZMultiplier = FRACUNIT/2
charmy.QuickAscentThrustDiagonalBoost = FRACUNIT*9/8
charmy.QuickAscentThrustSounds = {sfx_cdfm35, sfx_casnt1, sfx_casnt2}	-- same condition as charmy.QuickAscentChargeSounds
charmy.QuickAscentChargeVibrationStartup = {6, 2}	-- how long it takes to vibrate (scales with charge)
charmy.QuickAscentChargeVibrationTics = 1	-- how long to vibrate
charmy.QuickAscentSweatFrequency = TICRATE*4/10

-- stinger constants (strength is handled with S_SKIN mindash/maxdash)
charmy.StingerChargeTics = charmy.QuickAscentChargeTics	-- how long it takes to get to max charge
charmy.StingerChargeXYMultiplier = charmy.QuickAscentChargeXYMultiplier
charmy.StingerChargeZMultiplier = charmy.QuickAscentChargeZMultiplier
charmy.StingerTicConversion = {1, FRACUNIT*3/2}	-- [1] tics every [2] of speed
charmy.StingerDownThrustModifier = FRACUNIT*2/3	-- downwards thrust is a bit TOO strong...
charmy.StingerThrustZMultiplier = FRACUNIT/3	-- how much to cut momentum by
charmy.StingerThrustDiagonalAngle = ANGLE_22h
charmy.StingerChargeVibrationStartup = charmy.QuickAscentChargeVibrationStartup
charmy.StingerChargeVibrationTics = charmy.QuickAscentChargeVibrationTics
charmy.StingerStuckTics = TICRATE/4
charmy.StingerStuckPopUp = FRACUNIT*5
charmy.StingerStuckPopThrust = FRACUNIT*6

-- battlemod constants
charmy.SlowFallExhaustTime = TICRATE*2
charmy.AirChargeExhaustTime = TICRATE*7/4
charmy.PollenRingCost = 10
charmy.PollenCooldown = TICRATE*5/2
charmy.PollenTossSpeed = 44*FRACUNIT
charmy.PollenTossTics = TICRATE*2/3
charmy.PollenTossFrameTics = {3, 3, 2, 3}	-- keep in mind, once it hits frame 2 (index 3) is when the attack will happen!
charmy.PollenTossModifier = FRACUNIT*91/100
charmy.PollenTossXYRecoil = -(FRACUNIT*7)
charmy.PollenTossZRecoil = 5*FRACUNIT
charmy.PollenTravelTics = TICRATE*7/4
charmy.PollenTravelModifier = FRACUNIT*93/100
charmy.PollenTumbleTics = TICRATE*6/5
charmy.PollenTumbleThrust = FRACUNIT*4
charmy.PollenTumbleLaunch = FRACUNIT*10
charmy.PollenRadialRange = FRACUNIT*104
charmy.PollenRadialHeight = FRACUNIT*44	-- applies to both up and down
charmy.PollenMarkTics = TICRATE*12
charmy.PollenHomingTics = 10
charmy.PollenParticleModifier = FRACUNIT*8/10
charmy.PollenParticleDrop = -(FRACUNIT/4)
charmy.PollenParticleDropMax = -(FRACUNIT*7/4)
charmy.PollenParticleSpeedBounds = {FRACUNIT*6, FixedMul(FRACUNIT*2/3, charmy.PollenTossSpeed)}	-- {min speed, max speed}
charmy.PollenParticleTicBounds = {7, 3}	-- {slowest duration, fastest duration}
charmy.PollenPulsateTicBounds = {28, 6}
charmy.PollenPulsateScaleBounds = {FRACUNIT/12, FRACUNIT/5}
charmy.MarkedParticleFrequency = 4
charmy.MarkedOverlayFade = TICRATE/2	-- when it starts fading away
charmy.MarkedOverlayTrans = 5
charmy.MarkedOverlayPulsateTics = TICRATE*4/5
charmy.MarkedOverlayPulsateAdd = 2

-- quick ascent states (can change between FLY_ and GLID in script)
chaotix.SafeFreeslot("S_CHARMY_ASCENT_CHARGE", "S_CHARMY_ASCENT")
states[S_CHARMY_ASCENT_CHARGE] = {SPR_PLAY, SPR2_FLY_, 1, nil, 0, 0, S_CHARMY_ASCENT_CHARGE}
states[S_CHARMY_ASCENT] = {SPR_PLAY, SPR2_FLY_, 1, nil, 0, 0, S_CHARMY_ASCENT}

-- stinger states (can change between MLEE, MLEL and TWIN in script)
chaotix.SafeFreeslot("S_CHARMY_STINGER_CHARGE", "S_CHARMY_STINGER", "S_CHARMY_STINGER_STUCK")
states[S_CHARMY_STINGER_CHARGE] = {SPR_PLAY, SPR2_MLEE, 1, nil, 0, 0, S_CHARMY_STINGER_CHARGE}
states[S_CHARMY_STINGER] = {SPR_PLAY, SPR2_MLEE, 1, nil, 0, 0, S_CHARMY_STINGER}
states[S_CHARMY_STINGER_STUCK] = {SPR_PLAY, SPR2_LAND, -1, nil, 0, 0, S_CHARMY_STINGER_STUCK}

-- pollen toss state
chaotix.SafeFreeslot("S_CHARMY_POLLENTOSS")
states[S_CHARMY_POLLENTOSS] = {SPR_PLAY, SPR2_FIRE, -1, nil, 0, 0, S_CHARMY_POLLENTOSS}

-- pollen
function A_Charmy_PollenExplode(actor, var1, var2)
	-- visual effect
	for i = 1, 64
		local radius = actor.info.radius >> FRACBITS
		local xoff = P_RandomRange(-(radius), radius) * FRACUNIT
		local yoff = P_RandomRange(-(radius), radius) * FRACUNIT
		local zoff = P_RandomRange(0, actor.info.height >> FRACBITS) * FRACUNIT
		
		local pollen = P_SpawnMobjFromMobj(actor, xoff, yoff, zoff, MT_CHARMY_POLLEN_PARTICLE)
		pollen.color = actor.color
		pollen.fuse = P_RandomRange(TICRATE*4, TICRATE*6)
		P_Thrust(pollen, ANG1 * P_RandomRange(1, 360), FixedMul(actor.scale, P_RandomRange(18, 46) * FRACUNIT))
		P_SetObjectMomZ(pollen, P_RandomRange(-20, 20) * FRACUNIT)
	end
	chaotix.SpawnSoundMobj(actor, actor.info.deathsound)
	
	-- mark players caught!
	local range = charmy.PollenRadialRange
	searchBlockmap("objects", function(ref, found)
		if not ((found and found.valid) or found.health) then return end
		if not (abs(ref.z - found.z) <= FixedMul(ref.scale, charmy.PollenRadialHeight)) then return end
			
		-- player checks
		if not (found.player) then return end
		if (found == ref.target) then return end	-- dont debuff ourself!
		if (found == ref.tracer) then return end	-- dont debuff if they guarded!
		if (CBW_Battle and CBW_Battle.MyTeam(found.player, ref.target.player)) then return end
		
		if (CBW_Battle)
		and (found.player.guard > 0)	-- ...unless they're guarding!
			local B = CBW_Battle
			
			if (B.SkinVars[found.player.skinvars].func_guard_trigger)
				B.SkinVars[found.player.skinvars].func_guard_trigger(found, ref, ref.target)
			elseif (B.SkinVars[-1].func_guard_trigger)
				B.SkinVars[-1].func_guard_trigger(found, ref, ref.target)
			end
		else
			charmy.MarkPlayer(found.player, ref.target)
		end
	end, actor, actor.x - range, actor.x + range, actor.y - range, actor.y + range)
	
	-- debug range
	-- visuals for the explosion
	/*
	local thoks = 8
	for i = 1, thoks
		for j = -1, 1
			local angle = ((360/thoks) * i) * ANG1
			local xoff = (range/actor.scale) * cos(angle)
			local yoff = (range/actor.scale) * sin(angle)
			local zoff = ((charmy.PollenRadialHeight/actor.scale) * j)*FRACUNIT
			
			local thok = P_SpawnMobjFromMobj(actor, xoff, yoff, zoff, MT_THOK)
			thok.scale = $/2
			thok.frame = ($ & ~FF_TRANSMASK) | FF_FULLBRIGHT
			thok.color = SKINCOLOR_WHITE
			thok.tics = TICRATE/2
		end
	end*/
end

chaotix.SafeFreeslot("MT_CHARMY_POLLEN", "S_CHARMY_POLLEN", "S_CHARMY_POLLEN_RADIAL", "SPR_POLN")
states[S_CHARMY_POLLEN] = {SPR_POLN, A, charmy.PollenTravelTics, nil, 0, 0, S_CHARMY_POLLEN_RADIAL}
states[S_CHARMY_POLLEN_RADIAL] = {SPR_NULL, 0, 0, A_Charmy_PollenExplode, 0, 0, S_NULL}
mobjinfo[MT_CHARMY_POLLEN] = {
	spawnstate = S_CHARMY_POLLEN,
	deathstate = S_CHARMY_POLLEN_RADIAL,
	deathsound = sfx_s3k4b,
	radius = 24*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_SPECIAL|MF_SHOOTABLE|MF_NOGRAVITY|MF_BOUNCE,
}
chaotix.AddHook("MobjThinker", function(pollen)
	if not (pollen and pollen.valid) then return end
	
	-- modify momentum
	local modifier = charmy.PollenTravelModifier
	pollen.momx = FixedMul(modifier, $)
	pollen.momy = FixedMul(modifier, $)
	pollen.momz = FixedMul(modifier, $)
	
	-- pulsate, then explode!
	local ticbounds = charmy.PollenPulsateTicBounds
	local ticrange = ticbounds[1] - ticbounds[2]
	local maxtics = ticbounds[2] + ((pollen.tics * ticrange) / charmy.PollenTravelTics)
	
	pollen.charmy_pollen_tics = $ or 0	-- init
	pollen.charmy_pollen_tics = min(maxtics, $+1)
	if (pollen.charmy_pollen_tics >= maxtics) then pollen.charmy_pollen_tics = 0 end
	local tics = pollen.charmy_pollen_tics
	
	local cycle = ((tics % maxtics) * 360) / (maxtics - 1)
	
	local scalebounds = charmy.PollenPulsateScaleBounds
	local scalerange = scalebounds[2] - scalebounds[1]
	local scale = scalebounds[2] - ((pollen.tics * scalerange) / charmy.PollenTravelTics)
	local scaling = FixedMul(cos(cycle * ANG1), scale)
	
	pollen.spritexscale = FRACUNIT + scaling
	pollen.spriteyscale = FRACUNIT + scaling
	
	-- colour
	pollen.color = (G_GametypeHasTeams()) and pollen.target.color or SKINCOLOR_GOLD
		
	-- particles
	local speedbounds = charmy.PollenParticleSpeedBounds
	local speed = FixedHypot(pollen.momz, FixedHypot(pollen.momx, pollen.momy))
	
	if (speed >= speedbounds[1])
		speed = $ - speedbounds[1]	-- fix up the speed to make calculations easier
		local ticbounds = charmy.PollenParticleTicBounds
		local ticrange = ticbounds[1] - ticbounds[2]
		local duration = max(ticbounds[2], ticbounds[1] - ((speed * ticrange) / speedbounds[2]))
		
		if not (pollen.tics % duration)
			local radius = pollen.radius >> FRACBITS
			local xoff = P_RandomRange(-(radius), radius) * FRACUNIT
			local yoff = P_RandomRange(-(radius), radius) * FRACUNIT
			local zoff = P_RandomRange(0, pollen.height >> FRACBITS) * FRACUNIT
			
			local particle = P_SpawnMobjFromMobj(pollen, xoff, yoff, zoff, MT_CHARMY_POLLEN_PARTICLE)
			particle.color = pollen.color
			particle.fuse = TICRATE*2
		end
	end
end, MT_CHARMY_POLLEN)
chaotix.AddHook("TouchSpecial", function(pollen, mo)
	local B = CBW_Battle
	
	local target = pollen.target
	if not (target and target.valid) then return end
	local p = mo.player
	
	-- don't explode under these conditions
	if (pollen.state != S_CHARMY_POLLEN)	-- did we already explode???
	or (target == mo)	-- self protection
	or (B and B.MyTeam(p, target.player))	-- teammate protection
		return true
	end
	
	-- tumble them!
	if (B)
		if (p.guard > 0)	-- ...unless they're guarding!
			pollen.tracer = mo	-- keep track of who guarded it!
			if (B.SkinVars[p.skinvars].func_guard_trigger)
				B.SkinVars[p.skinvars].func_guard_trigger(mo, pollen, pollen.target)
			elseif (B.SkinVars[-1].func_guard_trigger)
				B.SkinVars[-1].func_guard_trigger(mo, pollen, pollen.target)
			end
		else
			local angle = R_PointToAngle2(pollen.x, pollen.y, mo.x, mo.y)
			local thrust = charmy.PollenTumbleThrust
			local launch = charmy.PollenTumbleLaunch
			
			P_SetObjectMomZ(mo, chaotix.WaterMom(mo, launch))
			B.DoPlayerTumble(mo.player, charmy.PollenTumbleTics, angle, FixedMul(mo.scale, thrust), true)
			charmy.MarkPlayer(mo.player, pollen.target)	-- make sure they're marked
		end
	end
	if not ((pollen and pollen.valid) and pollen.health) then return true end	-- it was already killed?
	
	-- kill it
	P_KillMobj(pollen)
	return true	-- so we dont get the target changed
end, MT_CHARMY_POLLEN)

-- pollen particles
chaotix.SafeFreeslot("MT_CHARMY_POLLEN_PARTICLE", "S_CHARMY_POLLEN_PARTICLE")
states[S_CHARMY_POLLEN_PARTICLE] = {SPR_POLN, B, -1, nil, 1, 5, S_CHARMY_POLLEN_PARTICLE}
mobjinfo[MT_CHARMY_POLLEN_PARTICLE] = {
	spawnstate = S_CHARMY_POLLEN_PARTICLE,
	deathstate = S_NULL,
	speed = TICRATE,
	radius = 1*FRACUNIT,
	height = 2*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY,
}
chaotix.AddHook("MobjThinker", function(pollen)
	if not ((pollen and pollen.valid) and pollen.health) then return end
	
	-- randomize frame
	if not (pollen.charmy_pollen_randomized)
		pollen.frame = P_RandomRange(1, 5)
		pollen.charmy_pollen_randomized = true
	end
	
	-- kill momentum
	if (pollen.charmy_pollen_tics == nil) then pollen.charmy_pollen_tics = pollen.info.speed end
	
	local modifier = charmy.PollenParticleModifier
	pollen.momx = FixedMul(modifier, $)
	pollen.momy = FixedMul(modifier, $)
	pollen.momz = FixedMul(modifier, $)
	
	-- limited drop
	P_SetObjectMomZ(pollen, charmy.PollenParticleDrop, true)
	if ((pollen.momz * P_MobjFlip(pollen)) < charmy.PollenParticleDropMax)
		pollen.momz = charmy.PollenParticleDropMax * P_MobjFlip(pollen)
	end
	
	-- move about while falling?
	if (pollen.charmy_pollen_shouldmove)
		A_BubbleRise(pollen, 0, 0)	-- set var2 to 0, we'll do the rest!
	else
		if not (FixedHypot(pollen.momx, pollen.momy) / pollen.scale)	-- start moving!
			A_BubbleRise(pollen, 0, 0)	-- here's a little to get us started
			pollen.charmy_pollen_shouldmove = true
		end
	end
	
	-- kill on ground
	if (P_IsObjectOnGround(pollen))
		P_KillMobj(pollen)
		return
	end
end, MT_CHARMY_POLLEN_PARTICLE)

--charmy wings
--STND
chaotix.SafeFreeslot("S_CHARMYWINGS_STND")
states[S_CHARMYWINGS_STND] = {SPR_PLAY, A|SPR2_TAL0|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_STND}
--WAIT
chaotix.SafeFreeslot("S_CHARMYWINGS_WAIT")
states[S_CHARMYWINGS_WAIT] = {SPR_PLAY, A|SPR2_TAL1|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_WAIT}
--WALK
chaotix.SafeFreeslot("S_CHARMYWINGS_WALK")
states[S_CHARMYWINGS_WALK] = {SPR_PLAY, A|SPR2_TAL2|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_WALK}
--RUN
chaotix.SafeFreeslot("S_CHARMYWINGS_RUN")
states[S_CHARMYWINGS_RUN] = {SPR_PLAY, A|SPR2_TAL3|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_RUN}
--SPRING
chaotix.SafeFreeslot("S_CHARMYWINGS_SPNG")
states[S_CHARMYWINGS_SPNG] = {SPR_PLAY, A|SPR2_TAL4|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_SPNG}
--FALL
chaotix.SafeFreeslot("S_CHARMYWINGS_FALL")
states[S_CHARMYWINGS_FALL] = {SPR_PLAY, A|SPR2_TAL5|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_FALL}
--GASP
chaotix.SafeFreeslot("S_CHARMYWINGS_GASP")
states[S_CHARMYWINGS_GASP] = {SPR_PLAY, A|SPR2_TAL6|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_GASP}
--RIDE
chaotix.SafeFreeslot("S_CHARMYWINGS_RIDE")
states[S_CHARMYWINGS_RIDE] = {SPR_PLAY, A|SPR2_TAL7|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_RIDE}
--CHARGE
chaotix.SafeFreeslot("S_CHARMYWINGS_CHARGE")
states[S_CHARMYWINGS_CHARGE] = {SPR_PLAY, A|SPR2_TAL8|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_CHARGE}
--NIGHTS FLY
chaotix.SafeFreeslot("S_CHARMYWINGS_NIGHTS_FLY")
states[S_CHARMYWINGS_NIGHTS_FLY] = {SPR_PLAY, A|SPR2_TAL9|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_NIGHTS_FLY}
--NIGHTS DRILL
chaotix.SafeFreeslot("S_CHARMYWINGS_NIGHTS_DRILL")
states[S_CHARMYWINGS_NIGHTS_DRILL] = {SPR_PLAY, A|SPR2_TALA|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_NIGHTS_DRILL}
--FKIK
chaotix.SafeFreeslot("S_CHARMYWINGS_KICK")
states[S_CHARMYWINGS_KICK] = {SPR_PLAY, A|SPR2_TALB|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_KICK}
--ROLLING
chaotix.SafeFreeslot("S_CHARMYWINGS_ROLL")
states[S_CHARMYWINGS_ROLL] = {SPR_PLAY, A|SPR2_TALC|FF_TRANS30, 1, nil, 0, 0, S_CHARMYWINGS_ROLL}
--wing mobj
chaotix.SafeFreeslot("MT_CHARMYWINGS")
mobjinfo[MT_CHARMYWINGS] = {
	doomednum = -1,
	spawnstate = S_NULL,
	flags = MF_NOCLIPHEIGHT,
	dispoffset = 2,
	radius = 10,
	height = 28
}

-- charmy's sweat
local sweat_frames = 4
local sweat_tics = 1
chaotix.SafeFreeslot("S_CHARMY_SWEAT", "MT_CHARMY_SWEAT", "SPR_CSWT")
states[S_CHARMY_SWEAT] = {SPR_CSWT, A|FF_ANIMATE, sweat_frames * sweat_tics, nil, sweat_frames - 1, sweat_tics, S_NULL}
mobjinfo[MT_CHARMY_SWEAT] = {
	spawnstate = S_CHARMY_SWEAT,
	deathstate = S_NULL,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SCENERY,
}
chaotix.AddHook("MobjThinker", function(sweat)
	local target = sweat.target
	if not (target and target.valid) then return end
	
	local z_offset = target.height
	if (target.eflags & MFE_VERTICALFLIP) then z_offset = target.height - sweat.height - z_offset end
	P_MoveOrigin(sweat, target.x, target.y, target.z + z_offset)
end, MT_CHARMY_SWEAT)