--wings hook
local charmy = chaotix.charmy

charmy.Wings = function(p)
	local mo = p.mo
	if not ((mo and mo.valid) and mo.health) then return end
	if (mo.skin != charmy.SKIN) then return end
	
	local followmobj = p.followmobj
	followmobj.skin = charmy.SKIN
	followmobj.flags2 = ($ &~ (MF2_DONTDRAW|MF2_SHADOW|MF2_SPLAT))
	| (mo.flags2 & (MF2_DONTDRAW|MF2_SHADOW|MF2_SPLAT)) | MF2_LINKDRAW
	followmobj.renderflags = mo.renderflags
	followmobj.sprite2 = SPR2_TAL0
	followmobj.angle = p.drawangle
	followmobj.rollangle = mo.rollangle
	followmobj.spriteyoffset = 0
	followmobj.scale = mo.scale
	followmobj.destscale = mo.destscale
	P_MoveOrigin(followmobj, mo.x-cos(p.drawangle), mo.y-sin(p.drawangle), followmobj.z)
	
	--charmy's wings!
	if p.followitem == MT_CHARMYWINGS and followmobj and followmobj.valid
		local shutupcharmy = true
		local sprite2 = mo.sprite2 &~ FF_SPR2SUPER
		local frame = mo.frame & FF_FRAMEMASK
		
		--charmy has semi-transparent wings
		followmobj.state = S_INVISIBLE	-- default to this, if we have no state
		followmobj.frame = FF_TRANS30
		
		--stand frames
		if sprite2 == SPR2_STND or sprite2 == SPR2_SKID
		or (sprite2 == SPR2_FALL and (CBW_Battle and p.exhaustmeter == 0))
			followmobj.state = S_CHARMYWINGS_STND
		end
		
		--wait frames
		if sprite2 == SPR2_WAIT
			followmobj.state = S_CHARMYWINGS_WAIT
			followmobj.frame = frame|FF_TRANS30
		end
		
		--walk frames
		if sprite2 == SPR2_WALK
			followmobj.state = S_CHARMYWINGS_WALK
			followmobj.frame = frame|FF_TRANS30
		end
		
		--run frames
		if sprite2 == SPR2_RUN_ or sprite2 == SPR2_PAIN
		or ((sprite2 == SPR2_FLY_ or sprite2 == SPR2_GLID) and mo.state != S_CHARMY_ASCENT)
			followmobj.state = S_CHARMYWINGS_RUN
			if sprite2 == SPR2_PAIN
				followmobj.spriteyoffset = -12*FRACUNIT
				followmobj.frame = 2|FF_TRANS30
			else
				followmobj.frame = 2*leveltime%6 / 2|FF_TRANS30
				shutupcharmy = false
			end
		end
		
		--spring/jump frames
		if sprite2 == SPR2_SPNG or sprite2 == SPR2_JUMP
		or ((sprite2 == SPR2_FLY_ or sprite2 == SPR2_GLID) and mo.state == S_CHARMY_ASCENT)
			followmobj.state = S_CHARMYWINGS_SPNG
			followmobj.frame = 0|FF_TRANS30
		end
		
		--fall frames
		if sprite2 == SPR2_FALL
		and not (CBW_Battle and p.exhaustmeter == 0)
			followmobj.state = S_CHARMYWINGS_FALL
			followmobj.frame = leveltime%8 / 2|FF_TRANS30
		end
		
		--gasp frames
		if sprite2 == SPR2_GASP
			followmobj.state = S_CHARMYWINGS_GASP
			followmobj.frame = 0|FF_TRANS30
		end
		
		--ride frames
		if sprite2 == SPR2_RIDE
			followmobj.state = S_CHARMYWINGS_RIDE
			followmobj.frame = 0|FF_TRANS30
		end
		
		--stinger charge
		if (sprite2 == SPR2_MLEE or sprite2 == SPR2_MLEL or sprite2 == SPR2_TWIN)
		and mo.state != S_CHARMY_STINGER
			followmobj.state = S_CHARMYWINGS_CHARGE
			followmobj.frame = 2*leveltime%6 / 2|FF_TRANS30
			shutupcharmy = false
			if sprite2 == SPR2_MLEE
				followmobj.spriteyoffset = -8*FRACUNIT
			end
		end
		
		--stinger dive
		if (sprite2 == SPR2_MLEE or sprite2 == SPR2_MLEL or sprite2 == SPR2_TWIN)
		and mo.state == S_CHARMY_STINGER
			followmobj.state = S_CHARMYWINGS_CHARGE
			followmobj.frame = 0|FF_TRANS30
			
			if sprite2 == SPR2_MLEE
				followmobj.spriteyoffset = -10*FRACUNIT
			end
		end
		
		--stinger stuck
		if sprite2 == SPR2_LAND or sprite2 == SPR2_CLNG
			followmobj.state = S_CHARMYWINGS_CHARGE
			followmobj.frame = 0|FF_TRANS30
			
			if sprite2 == SPR2_CLNG
				followmobj.spriteyoffset = -10*FRACUNIT
			else
				followmobj.spriteyoffset = -2*FRACUNIT
			end
		end
		
		--nights fly
		if sprite2 == SPR2_NFLY or sprite2 == SPR2_NPUL
			followmobj.state = S_CHARMYWINGS_NIGHTS_FLY
			followmobj.frame = 0|FF_TRANS30
		end
		
		--nights drill
		if sprite2 == SPR2_NDRL
			followmobj.state = S_CHARMYWINGS_NIGHTS_DRILL
			followmobj.frame = frame|FF_TRANS30
		end
		
		--roll frames
		if sprite2 == SPR2_ROLL or sprite2 == SPR2_NATK
			followmobj.state = S_CHARMYWINGS_ROLL
			followmobj.frame = frame|FF_TRANS30
			if frame == 1 or frame == 2
				P_MoveOrigin(followmobj, mo.x+cos(p.drawangle), mo.y+sin(p.drawangle), followmobj.z)
			end
		end
		
		--kick (milne)
		if sprite2 == SPR2_FKIK
			followmobj.state = S_CHARMYWINGS_KICK
			followmobj.frame = frame|FF_TRANS30
		end
		
		-- pollen toss (battlemod)
		if sprite2 == SPR2_FIRE
			if (frame < 3)
				followmobj.state = S_CHARMYWINGS_GASP
			else
				followmobj.state = S_CHARMYWINGS_RUN
			end
			followmobj.frame = 0|FF_TRANS30
		end
		
		-- buzzing sound (not entirely synced to leveltime!)
		if not (shutupcharmy)
			if (followmobj.charmy_buzztime == nil) then followmobj.charmy_buzztime = leveltime end
			
			local buzztime = leveltime - followmobj.charmy_buzztime
			if not (buzztime % 2) then S_StartSound(followmobj, sfx_buzz4) end
		else
			followmobj.charmy_buzztime = nil
		end
		
		--edge frames
		if sprite2 == SPR2_EDGE
			if (frame == 0)
				followmobj.state = S_CHARMYWINGS_STND
				followmobj.frame = 0|FF_TRANS30
			end
			if (frame == 1) or (frame == 3)
				followmobj.state = S_CHARMYWINGS_SPNG
				followmobj.frame = 0|FF_TRANS30
			end
			if (frame == 2)
				followmobj.state = S_CHARMYWINGS_RUN
				followmobj.frame = 2|FF_TRANS30
				followmobj.spriteyoffset = -2*FRACUNIT
			end
		end
		
		--get frame visuals from the player for everything else
		followmobj.frame = $ | (mo.frame &~ (FF_FRAMEMASK|FF_TRANSMASK))
	end
end