-- fix vector's height for drowning
local vector = chaotix.vector

vector.DrowningHeightFix = function(p)
	local mo = p.mo
	if not ((mo and mo.valid) and mo.health) then return end
	if not (mo.skin == vector.SKIN) then return end
	
	-- phant if you dont at least indent your code i'm gonna murder you!!!
	local underwaterheight = -(mo.watertop - mo.z)/638977	-- very specific number
	if underwaterheight > -6 and underwaterheight < 0 -- cannot drown this deep
		p.powers[pw_underwater] = 0
		P_RestoreMusic(p)
	end
end

-- jukebox wait, listen to tunes!
vector.Jukebox_Table = {
	-- now with more accuracy!
	{name = "This Horizon", loopsound = chaotix.SafeFreeslot("sfx_vecjb1"), bpm = 148},
	{name = "Door into Summer", loopsound = chaotix.SafeFreeslot("sfx_vecjb2"), bpm = 128},
	{name = "Walkin'", loopsound = chaotix.SafeFreeslot("sfx_vecjb3"), bpm = 119},
	{name = "Evening Star", loopsound = chaotix.SafeFreeslot("sfx_vecjb4"), bpm = 109},
	{name = "Seascape", loopsound = chaotix.SafeFreeslot("sfx_vecjb5"), bpm = 120},
	{name = "Midnight Greenhouse", loopsound = chaotix.SafeFreeslot("sfx_vecjb6"), bpm = 108},
	{name = "Combination", loopsound = chaotix.SafeFreeslot("sfx_vecjb7"), bpm = 110},
	[-1] = {name = "Team Chaotix", loopsound = chaotix.SafeFreeslot("sfx_vecjb8"), bpm = 144},
}
for _, songinfo in pairs(vector.Jukebox_Table)
	-- set flags and remove empty captions
	local songflags = vector.JukeboxDefaultFlags
	if (songinfo.flags != nil) then songflags = songinfo.flags end	-- potential override?
	
	local startsound = songinfo["loopsound"]
	if (startsound)
		local info = sfxinfo[startsound]
		info.flags = songflags
		chaotix.RemoveEmptyCaption(info)
	end
	
	local loopsound = songinfo["loopsound"]
	if (loopsound)
		local info = sfxinfo[loopsound]
		info.flags = songflags
		chaotix.RemoveEmptyCaption(info)
	end
end
/*COM_AddCommand("vector_setbpm", function(p, bpm)
	bpm = tonumber($)
	if not (bpm) then return end
	
	p.mo.vector_wait_bpm = FixedDiv((60*TICRATE)<<FRACBITS, bpm << FRACBITS)
end)*/

-- now for the functions that play the music!
local function vector_resetWait(mo)
	-- stop any sounds
	if (mo.vector_wait_songindex)
		local songinfo = vector.Jukebox_Table[mo.vector_wait_songindex]
		local startsound = songinfo["startsound"]
		local loopsound = songinfo["loopsound"]
		
		if (startsound and S_SoundPlaying(mo, startsound))
			S_StopSoundByID(mo, startsound)
		end
		if (loopsound and S_SoundPlaying(mo, loopsound))
			S_StopSoundByID(mo, loopsound)
		end
		mo.vector_wait_songindex = nil
		
		-- also reset the music too while we're at it!
		S_FadeMusic(100, vector.JukeboxFadeInTime, mo.player)	-- go back to full volume
	end
	
	-- reset common vars
	mo.vector_wait_songindex = nil
	mo.vector_wait_bpm = nil
	mo.vector_wait_tics = nil
	mo.vector_wait_set = nil
	mo.vector_wait_started = nil
	mo.vector_wait_dielit = nil
end

vector.Jukebox = function(p)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	if (mo.skin != vector.SKIN) then vector_resetWait(mo) return end
	
	/*if (mo.state == S_PLAY_NIGHTS_STAND)
		mo.sprite2 = SPR2_WAIT	-- gonna be neat to have this working in special stages!
	end*/
	if (mo.sprite2 != SPR2_WAIT) then vector_resetWait(mo) return end
	
	-- fetch the song to play!
	if not (mo.vector_wait_set)
		if mo.vector_wait_dielit
			mo.vector_wait_songindex = -1
		else
			mo.vector_wait_songindex = P_RandomRange(1, table.maxn(vector.Jukebox_Table))
		end
		local songinfo = vector.Jukebox_Table[mo.vector_wait_songindex]
		
		-- set bpm
		local bpm = songinfo["bpm"]
		bpm = FixedDiv((60*TICRATE)<<FRACBITS, bpm << FRACBITS)
		mo.vector_wait_bpm = bpm
		
		-- timer for the animation
		mo.vector_wait_tics = 0
		
		-- die lit
		mo.vector_wait_dielit = $ or false
		
		-- fade the music
		S_FadeMusic(vector.JukeboxFadeVolume, vector.JukeboxFadeOutTime, mo.player)	-- go back to full volume
		
		-- send a closed caption
		/*if (songinfo["name"])
			-- use a ridiculous caption length
			local lifespan = vector.JukeboxCaptionTics
			S_StartMusicCaption(songinfo["name"], INT32_MAX, p)
		end*/
		
		-- don't do this again
		mo.vector_wait_set = true
	end
	
	-- play the music!
	local songinfo = vector.Jukebox_Table[mo.vector_wait_songindex]
	local startsound = songinfo["startsound"]
	local loopsound = songinfo["loopsound"]
	
	-- don't help taggers find hiders!
	if G_TagGametype() and not splitscreen
	and displayplayer and displayplayer.valid and displayplayer.mo
	and (displayplayer.pflags & PF_TAGIT != p.pflags & PF_TAGIT)
		if not mo.vector_wait_started then mo.vector_wait_started = true end
		
	-- start of the music
	elseif (startsound and not S_SoundPlaying(mo, startsound))
	and not (mo.vector_wait_started)
		S_StartSound(mo, startsound)
		mo.vector_wait_started = true
		
	-- music loop
	else
		if (loopsound and not S_SoundPlaying(mo, loopsound))	-- loop sound isnt currently playing
		and not (startsound and S_SoundPlaying(mo, startsound))	-- start sound isnt playing still
			S_StartSound(mo, loopsound)
		end
	end
	
	-- handle the animation!
	local offset = 0	-- init
	local frames = 6	-- wait frame count
	local beats_per_animloop = 2	-- how many beats per animation loop
	if (mo.vector_wait_dielit)	-- get lit
		offset = frames	-- skip old frames
		frames = 4	-- new frame count
		beats_per_animloop = 1	-- 1 loop every beat
	end
	
	local bpm = mo.vector_wait_bpm
	local curtics = mo.vector_wait_tics
	local work = (curtics << FRACBITS) % (bpm * beats_per_animloop)	-- i dont understand this code at all BUT THIS EDIT WORKS SO SUCK IT LETS GOOOO
	if (curtics >= (FRACUNIT >> 1)) then mo.vector_wait_tics = (work >> FRACBITS) end
	
	work = FixedDiv(work * frames, bpm * beats_per_animloop)
	chaotix.SetFrame(mo, (work / FRACUNIT) + offset)
	mo.vector_wait_tics = $ + 1
end

-- die lit
chaotix.AddHook("PlayerMsg", function(p, msgtype, target, msg)
	if (msgtype) then return end	-- needs to be a regular message
	
	-- mobj checks
	local mo = p.mo
	if not ((mo and mo.valid) and mo.health) then return end	-- gotta be alive
	if (mo.skin != vector.SKIN) then return end	-- we gotta be vector
	if (mo.state != S_PLAY_STND and mo.state != S_PLAY_WAIT) then return end	-- gotta be waiting
	if (mo.vector_wait_dielit) then return end	-- already lit
	if (p.speed) then return end	-- can't be moving!
	if not (P_IsObjectOnGround(mo)) then return end	-- gotta be grounded
	
	-- check message
	msg = $:lower()
	if (msg == "die lit" and not mo.vector_wait_dielit)	-- die lit
		p.panim = PA_IDLE	-- this should make us interupt it
		mo.state = S_PLAY_WAIT
		if mo.vector_wait_set
			vector_resetWait(mo)
		end
		mo.vector_wait_dielit = true
		
		-- just start at the first frame
		chaotix.SetFrame(mo, G)
		return true
	end
end)

-- handle closed captions for vector's jukebox
local jukebox_captions = {}
local CLIPPING_DIST = (1536*0x10000)	-- pulled from source

vector.JukeboxCaptions = function()
	-- check to see what jukebox songs can be heard (no support for SF_OUTSIDESOUND but who cares)
	local heard_songs = {}
	
	local checkplayer = displayplayer
	while (checkplayer and checkplayer.valid)
		-- check in a radius
		local checkmo = checkplayer.mo
		if (checkmo and checkmo.valid)
			-- determine what the "listener" is
			local checkcamera = (checkplayer == displayplayer) and camera or camera2
			local listener = (checkcamera.chase) and checkcamera or checkmo
			
			for p in players.iterate
				local mo = p.mo
				if not (mo and mo.valid) then continue end
				
				-- are they even listening to anything?
				if not (mo.vector_wait_songindex) then continue end
				local songinfo = vector.Jukebox_Table[mo.vector_wait_songindex]
				if not (songinfo.name) then continue end	-- no name!
				
				-- approx. dist calculation (ripped from S_CalculateSoundDistance)
				if (mo != checkmo)	-- no need, we ARE the source!
					local listener_x, listener_y, listener_z = listener.x, listener.y, listener.z
					local source_x, source_y, source_z = mo.x, mo.y, mo.z
					
					local approx_dist, adx, ady
					
					// calculate the distance to sound origin and clip it if necessary
					adx = abs((listener_x>>FRACBITS) - (source_x>>FRACBITS))
					ady = abs((listener_y>>FRACBITS) - (source_y>>FRACBITS))

					// From _GG1_ p.428. Approx. euclidian distance fast.
					// Take Z into account
					adx = adx + ady - ((adx < ady and adx or ady)>>1)
					ady = abs((listener_z>>FRACBITS) - (source_z>>FRACBITS))
					approx_dist = adx + ady - ((adx < ady and adx or ady)>>1)

					if (approx_dist >= FRACUNIT/2)
						approx_dist = FRACUNIT/2-1
					end

					approx_dist = $ << FRACBITS
					
					-- have flags affect the approx. dist
					local songflags = vector.JukeboxDefaultFlags
					if (songinfo.flags != nil) then songflags = songinfo.flags end	-- potential override?
					
					if (songflags & SF_X8AWAYSOUND) then approx_dist = FixedDiv($, 8*FRACUNIT) end
					if (songflags & SF_X4AWAYSOUND) then approx_dist = FixedDiv($, 4*FRACUNIT) end
					if (songflags & SF_X2AWAYSOUND) then approx_dist = FixedDiv($, 2*FRACUNIT) end
					
					-- too far away?
					if (approx_dist > CLIPPING_DIST) then continue end
				end
				
				-- add the song to our heard songs!
				heard_songs[mo.vector_wait_songindex] = true
			end
		end
		
		-- try do this for secondarydisplayplayer
		if (secondarydisplayplayer and secondarydisplayplayer.valid)
		and (checkplayer != secondarydisplayplayer)	-- nvm, we just did this!
			checkplayer = secondarydisplayplayer
			continue
		end
		
		-- cease functions
		break
	end
	
	-- update captions!
	for index, songinfo in pairs(vector.Jukebox_Table)
		if not (jukebox_captions[index])	-- song caption isnt shown
			if not (heard_songs[index]) then continue end	-- song isnt playing, dont start caption
			
			-- start the caption
			jukebox_captions[index] = true
			S_StartMusicCaption(songinfo["name"], INT32_MAX, p)	-- set this ridiculously high
			//print(songinfo["name"].." detected")
		else	-- song caption IS shown
			if (heard_songs[index])	then continue end	-- song is playing, dont remove caption
			
			-- remove the caption
			jukebox_captions[index] = nil
			S_StartMusicCaption(songinfo["name"], vector.JukeboxFadeInTime, p)
			//print(songinfo["name"].." not detected")
		end
	end
end

-- spawn a headset on death!
vector.HeadsetDeath = function(mo, inflictor, source, damagetype)
	if (mo.skin != vector.SKIN) then return end
	mo.vector_damagetype = damagetype
end
vector.HeadsetDeathThinker = function(p)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	if (mo.skin != vector.SKIN) then return end
	
	-- reset conditions
	if (mo.health)	-- we're alive???
		mo.vector_headsetdeath = nil
		mo.vector_damagetype = nil
		return
	end
	if (mo.vector_headsetdeath) then return end	-- already done
	
	-- shoot off the headset!
	local headset = P_SpawnMobjFromMobj(mo, 0, 0, FixedDiv(mo.height, mo.scale), MT_GHOST)
	P_SetMobjStateNF(headset, S_VECTOR_HEADSET)
	headset.target = mo
	headset.color = mo.color
	headset.flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
	headset.momz = mo.momz	-- keep momz
	headset.vector_isheadset = true	-- god.
	mo.vector_headsetdeath = true	-- only do this once!
	
	-- different stuff depending on damagetype
	local damagetype = mo.vector_damagetype
	headset.vector_drowned = (damagetype == DMG_DROWNED or damagetype == DMG_SPACEDROWN)
	
	if not (headset.vector_drowned)	-- we don't want to launch it when we drown
		-- launch the headset (make sure it's to the side!
		local whichside = (P_RandomRange(0, 1)) and 1 or -1
		local offset = vector.HeadsetDeathAngleOffset
		local angle = mo.angle + (ANGLE_90 * whichside) + (P_RandomRange(-(offset), offset) * ANG1)
		local bounds = vector.HeadsetDeathThrustBounds
		local range = bounds[2] - bounds[1]
		local thrust = bounds[1] + ((range * P_RandomRange(1, FRACUNIT)) / FRACUNIT)
		
		headset.angle = mo.angle	-- might be able to preserve rollangle in multiplayer this way?
		P_InstaThrust(headset, angle, FixedMul(mo.scale, thrust))
		P_SetObjectMomZ(headset, vector.HeadsetDeathLaunch, true)	-- add some more
		headset.vector_launchangle = whichside	-- instead of using angle math, i can just use this!
	end
end

-- thumbs up pose while running!
local function vector_resetRun(mo)
	mo.vector_pose_lowerchance = nil
	mo.vector_pose_tics = nil
	mo.vector_pose_frame = nil
	mo.vector_pose_frametics = nil
	mo.vector_pose_cooldown = nil
			
	-- reset stretch stuff
	if (mo.vector_pose_stretch)
		mo.spriteyscale = FRACUNIT
		mo.vector_pose_stretch = nil
	end
end

vector.RunningThinker = function(p)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	if (mo.skin != vector.SKIN) then vector_resetRun(mo) return end
	
	-- handle the odds for the thumbs up
	local speed = FixedDiv(p.speed, mo.scale)
	
	if (mo.vector_pose_cooldown)	-- unless we have a cooldown
		mo.vector_pose_cooldown = $-1
	else
		if not (mo.vector_pose_tics)
			-- calculate chance
			if (mo.vector_pose_lowerchance == nil) then mo.vector_pose_lowerchance = 0 end
				
			local basechance = vector.ThumbsUpBaseChance - ((speed * vector.ThumbsUpChanceSpeedReduce) / (52<<FRACBITS))
			local chance = basechance - mo.vector_pose_lowerchance
			local rolledPose = not (P_RandomKey(max(1, chance)))
			mo.vector_pose_lowerchance = $+1	-- have a higher chance next roll!
				
			-- once we roll it, lock it in for a bit for when we start running!
			if (rolledPose) 
			and (mo.state == S_PLAY_RUN)
				local bounds = vector.ThumbsUpTicBounds
				mo.vector_pose_lowerchance = 0	-- once we actually show the pose, reset the chance lower!
				mo.vector_pose_tics = P_RandomRange(bounds[1], bounds[2])
				mo.vector_pose_stretch = vector.ThumbsUpStretchTics
			end
		end
	end
	
	-- handle the thumbs up frame setting!
	if (mo.vector_pose_tics)
		-- exit this
		if (mo.state != S_PLAY_RUN) 
			-- add a cooldown
			mo.vector_pose_cooldown = vector.ThumbsUpCooldownTics
			
			-- reset these
			mo.vector_pose_tics = nil
			mo.vector_pose_frame = nil
			mo.vector_pose_frametics = nil
			
			-- reset stretch stuff
			mo.spriteyscale = FRACUNIT
			mo.vector_pose_stretch = nil
			return 
		end
		
		-- stretch!
		if (mo.vector_pose_stretch)
			local yrange = vector.ThumbsUpStretch - FRACUNIT
			local yscale = FRACUNIT + ((mo.vector_pose_stretch * yrange) / vector.ThumbsUpStretchTics)
			mo.spriteyscale = yscale
			
			mo.vector_pose_stretch = $-1
		end
		
		-- get frame number
		if (mo.vector_pose_frame == nil) then mo.vector_pose_frame = (mo.frame & FF_FRAMEMASK) end
		if (mo.vector_pose_frametics == nil) then mo.vector_pose_frametics = mo.tics end
		
		speed = FixedDiv(p.speed, FixedMul(mo.scale, mo.movefactor))	-- frame speed is affected by movefactor, so recalculate!
		local maxtics = (speed > 52<<FRACBITS) and 1 or 2
		local numframes = 4
		
		mo.vector_pose_frametics = min(maxtics, $) - 1
		if not (mo.vector_pose_frametics)
			mo.vector_pose_frametics = maxtics
			mo.vector_pose_frame = $+1
			
			if (mo.vector_pose_frame > (numframes - 1))
				mo.vector_pose_frame = 0
			end
		end
		
		-- set sprite + frame
		mo.vector_pose_tics = $-1
		local spr2 = (mo.vector_pose_tics) and SPR2_DASH or SPR2_RUN_
		mo.sprite2 = spr2
		chaotix.SetFrame(mo, mo.vector_pose_frame, spr2)
		
		-- reset variables and set a cooldown
		if not (mo.vector_pose_tics)
			mo.vector_pose_frame = nil
			mo.vector_pose_frametics = nil
			mo.vector_pose_cooldown = vector.ThumbsUpCooldownTics
			
			-- reset stretch stuff
			mo.spriteyscale = FRACUNIT
			mo.vector_pose_stretch = nil
		end
	end
end

-- vector's teeter animation needs a unique animation speed
vector.TeeterAnimation = function(p)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	if (mo.skin != vector.SKIN) then mo.vector_teeterleveltime = nil return end
	
	if (mo.sprite2 != SPR2_EDGE) then mo.vector_teeterleveltime = nil return end
	
	-- init vars
	if (mo.vector_teeterleveltime == nil) then mo.vector_teeterleveltime = leveltime end	-- so the animation always starts from the first frame
	local teetertime = leveltime - mo.vector_teeterleveltime
	
	-- set frame
	local frames = 4	-- frame count of the animation
	local tics = 4	-- tics per frame
	chaotix.SetFrame(mo, (teetertime % (frames * tics)) / tics)
end

-- make vector look down after finishing NiGHTS special stages
vector.NiGHTSFinishState = function(p)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	if (mo.skin != vector.SKIN) then return end
	
	if (p.powers[pw_carry] != CR_NIGHTSMODE) then return end
	
	if (p.exiting and mo.state == S_PLAY_NIGHTS_FLOAT)
		mo.state = S_PLAY_FALL
	end
end