-- all of bomb's hooks
local bomb = chaotix.bomb

bomb.CupCake = function(p)
	local mo = p.mo
	if not (p.bomb_cupcake) then return end
	if not (mo and mo.valid and mo.health and mo.skin == bomb.SKIN
	and (mo.state == S_BOMB_CUPCAKE or mo.state == S_PLAY_MELEE_FINISH)) then
		p.bomb_cupcake = 0
		if mo.state == S_BOMB_CUPCAKE or mo.state == S_PLAY_MELEE_FINISH
			mo.state = S_PLAY_STND
		end
		return
	end
	
	p.pflags = $ | PF_FULLSTASIS
	if mo.state == S_PLAY_MELEE_FINISH
		for i = 1, #bomb.VolatileFlags
			bomb.TriggerVolatile(p, 2 ^ (i - 1))
		end
		
		p.bomb_cupcake = 2
		
		-- kill us
		P_DamageMobj(mo, nil, nil, 1000, DMG_INSTAKILL | DMG_CANHURTSELF)
		mo.bomb_explode = true
		mo.bomb_explode_tics = bomb.ExplodeDeathTics - 1	-- set tics to the moment we're supposed to explode
		mo.bomb_explode_exploded = true	-- hack
		
		-- affect things in a range
		local range = FixedMul(mo.scale, bomb.MeltdownSelfDestructRange)
		local underwater_modifier = (mo.eflags & MFE_UNDERWATER) and bomb.VolatileUnderwaterNerf or FRACUNIT
		bomb.SpawnExplosion(mo, FixedMul(underwater_modifier, range), true)
		S_StartSound(mo, sfx_kc3b)
		
		p.bomb_cupcake = 0
	elseif (mo.frame & FF_FRAMEMASK) == F and mo.tics == 4
		-- message and sound
		COM_BufInsertText(p, "say C'mere cupcake!")
		S_StartSound(mo, sfx_bomcup)
	elseif (mo.frame & FF_FRAMEMASK) == C and mo.tics == 4
		local mobjtype = p.rings and MT_FLINGRING or MT_EXPLODE
		
		local angle = (p.cmd.angleturn<<16) + ANGLE_90
		local radius = FixedDiv(mo.radius, mo.scale)*3/2
		local ring = P_SpawnMobjFromMobj(mo,
		P_ReturnThrustX(mo, angle, radius),
		P_ReturnThrustY(mo, angle, radius),
		p.height/2, mobjtype)
		ring.flags = $ | MF_NOCLIPTHING | MF_NOCLIPHEIGHT
		ring.fuse = TICRATE/2
		ring.shadowscale = 0
		
		if p.rings
			S_StartSound(mo, sfx_antiri)
			P_GivePlayerRings(p, -1)
			
			P_SpawnMobjFromMobj(ring, 0,0,0, MT_SPARK)
			P_SetObjectMomZ(ring, FRACUNIT*4)
			P_InstaThrust(ring, angle, mo.scale*4)
		else
			S_StartSound(mo, sfx_pop)
		end
	elseif (mo.frame & FF_FRAMEMASK) >= O
		mo.tics = 1
	end
end

bomb.PlayerMsg = function(p, msgtype, target, msg)
	if (msgtype) then return end	-- needs to be a regular message
	if not (gamestate == GS_LEVEL or titlemapinaction) then return end -- need to be in a level
	
	-- bomb checks
	local mo = p.mo
	if not (mo and mo.valid and mo.health and mo.skin == bomb.SKIN) then return end -- need an object
	if not (P_IsObjectOnGround(mo)) then return end	-- gotta be grounded
	if not (p.panim >= PA_IDLE and p.panim <= PA_RUN) then return end -- panim sanity checks
	if (p.isjettysyn or p.powers[pw_carry]) then return end	-- NO
	
	-- check message
	msg = $:lower()
	if (msg == "cupcake") -- start the pow state
		p.bomb_cupcake = 1
		mo.state = S_BOMB_CUPCAKE
		return true
	end
end