-- all of bomb's hooks
local bomb = chaotix.bomb

chaotix.AddHook("AbilitySpecial", function(p)
	-- reset fuse dash vars
	local mo = p.mo
	if (mo and mo.valid) then bomb.ResetFuseDash(mo) end
	
	-- activate the fuse shot
	bomb.ActivateFuseShot(p)
end)

chaotix.AddHook("SpinSpecial", bomb.SpinSpecial)	-- fuse dash activation
chaotix.AddHook("JumpSpecial", bomb.JumpSpecial)	-- jumping while spinning

chaotix.AddHook("ThinkFrame", do
	bomb.BattleSetup()
	for p in players.iterate
		if (bomb.VolatileHitlag(p)) then continue end	-- nope
		bomb.CupCake(p)
		bomb.ThokkedState(p)
		bomb.Explode(p)
		bomb.FuseShot(p)
		bomb.FuseDash(p)
		bomb.TopSpin(p)
		bomb.Volatile(p)
	end
end)

-- make sure bomb can damage correctly
chaotix.AddHook("PlayerCanDamage", function(p) 
	local mo = p.mo
	if not ((mo and mo.valid) and mo.health) then return end
	
	-- return true while volatile!
	if (mo.bomb_volatile)
		return true
	end
	
	-- top spin damage
	if (mo.state >= S_BOMB_TOPSPIN and mo.state <= S_BOMB_TOPSPIN_FAST)
		return true
	end
end)

-- damage hook
bomb.MobjDamage = function(mobj, mo)
	if not (mobj and mobj.valid) then return end
	if (bomb.VolatileDamage(mobj, mo)) then return end	-- got volatile damage
	if (bomb.ExplodeDamage(mobj)) then return end	-- start exploding???
end
chaotix.AddHook("MobjDamage", bomb.MobjDamage)
chaotix.AddHook("MobjDeath", bomb.MobjDamage)

-- additional death hook for exploding
chaotix.AddHook("MobjDeath", function(mo)
	bomb.ExplodeDamage(mo)
end, MT_PLAYER)

-- mobjmoveblocked hook
chaotix.AddHook("MobjMoveBlocked", function(mo, thing, line)
	if not ((mo and mo.valid) and mo.health) then return end
	
	if (bomb.VolatileMoveBlocked(mo, thing, line)) then return end
	if (bomb.FuseShotMoveBlocked(mo)) then return end
end)

-- playermsg hook
chaotix.AddHook("PlayerMsg", bomb.PlayerMsg)