-- bomb has a custom thokked handler
local bomb = chaotix.bomb

bomb.AddThokked = function(p, flag)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	mo.bomb_thokked = $ and $|(flag) or flag
	p.pflags = $|(PF_THOKKED)	-- also set this
end
bomb.ResetThokked = function(p)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	
	local thokked = mo.bomb_thokked
	mo.bomb_thokked = 0
	if (thokked) then p.pflags = $ & ~(PF_THOKKED) end	-- also remove this
end

bomb.ThokkedState = function(p)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	
	-- bomb ability check
	if not (bomb.AbilityCheck(p, 1) or bomb.AbilityCheck(p, 2))
		bomb.ResetThokked(p)
		return
	end
	
	-- init thokked state
	mo.bomb_thokked = $ or 0
	
	-- reset thokked state
	if (P_IsObjectOnGround(mo))
	or (p.powers[pw_carry])
		bomb.ResetThokked(p)
		return
	end
	
	-- set regular PF_THOKKED alongside our expanded PF_THOKKED state
	if (mo.bomb_thokked)
		p.pflags = $|(PF_THOKKED)
	else
		-- little bit of a hack...
		if (p.pflags & PF_THOKKED)
			bomb.AddThokked(p, bomb.ThokkedFlags["FUSESHOT"])
			bomb.AddThokked(p, bomb.ThokkedFlags["FUSEDASH"])
		end
	end
end