-- bomb's special state, topspin
local bomb = chaotix.bomb

-- state to set it
bomb.SetTopSpinState = function(p)
	local mo = p.mo
	if not ((mo and mo.valid) and mo.health) then return end
	
	-- not bomb?
	if (mo.skin != bomb.SKIN)
		mo.state = S_PLAY_ROLL
		return
	end
	
	if (p.speed >= FixedMul(mo.scale, bomb.TopSpinFastThreshold))
		mo.state = S_BOMB_TOPSPIN_FAST
		mo.tics = min(2, $)	-- fast
	else
		mo.state = S_BOMB_TOPSPIN
		if (p.speed >= FixedMul(mo.scale, bomb.TopSpinThreshold))
			mo.tics = 1
		end
	end
end

-- topspin state thinker
bomb.TopSpin = function(p)
	local mo = p.mo
	if not ((mo and mo.valid) and mo.health) then return end
	
	-- make sure we're in the topspin state
	if not (mo.state >= S_BOMB_TOPSPIN and mo.state <= S_BOMB_TOPSPIN_FAST)
		-- we can still go into the top spin state if we're interupted from a spindash!
		if not ((p.pflags & (PF_SPINNING|PF_STARTDASH) == PF_SPINNING)
		and (mo.state == S_PLAY_SPINDASH))
			-- okay, failsafe failed
			return 
		end
	end
	bomb.SetTopSpinState(p)
end

-- make bomb jump in his topspin frames
bomb.JumpSpecial = function(p)
	local mo = p.mo
	if not ((mo and mo.valid) and mo.health) then return end
	
	-- only bomb
	if (mo.skin != bomb.SKIN) then return end
	
	-- jump into his top spin frames!
	if (P_IsObjectOnGround(mo))
	and not (p.pflags & PF_JUMPDOWN)
	and (p.pflags & PF_SPINNING)
		P_DoJump(p, true)
		bomb.SetTopSpinState(p)
		return true
	end
end