chaotix.CV_Debug = CV_RegisterVar{
	name = "mechanixdebug",
	defaultvalue = 0,
	PossibleValue = CV_OnOff
}

//*** HUD infrastructure
local xoffset, yoffset, flags, nextline, align

local addspace = function()
	yoffset = $+nextline
end
local addline = function(string,string2, v)
	if type(string2) == "table" --Count entries instead
		string = "#"..tostring($)
		string2 = #$
	elseif type(string2) == "userdata" --Get userdata type
		string2 = userdataType($)
	end
	--Combine into single string
	string = "\x86"+tostring($)+": \x80"+tostring(string2)
	v.drawString(xoffset,yoffset,string,flags,align)
	yoffset = $+nextline
end
local addheader = function(string, v)
	--Give us a nice color header
	yoffset = $+nextline
	string = "\x82"+string
	v.drawString(xoffset,yoffset,string,flags,align)
	yoffset = $+nextline
end
local subheader = function(string, v)
	--For when the top-level header just isn't enough
	string = "\x88"+string
	v.drawString(xoffset,yoffset,string,flags,align)
	yoffset = $+nextline
end

local addlist = function(t, v)
	--Deconstructs a table and lists all of its elements in the display
	for n, e in pairs(t) do
		addline(n, e, v)
	end
end

-- Main HUD controller
local DebugHUD = function(v, player, cam) --Main Debug HUD controller
	local debug = chaotix.CV_Debug.value
	if not(debug) then return end

	//Setup vars
	xoffset = 320
	yoffset = 1
	flags = V_HUDTRANS|V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER
	align = "small-right"
	nextline = 4
	//Double the scale for smaller screens (illegible otherwise)
	if v.height() < 400 then 
		align = "right"
		nextline = 8
	end
	
	//****
	//Execute drawing
	//****	
	local mo = player.mo
	if mo and player.bomb
		addheader("Bomb (Lach)", v)
		addlist(player.bomb, v)
		subheader("Flags", v)
-- 		addline("MF_EXPLOSION", mo.flags & MF_EXPLOSION != 0, v)
	end
	if mo and mo.bombvars
		addheader("BombVars (CBW)", v)
		addlist(mo.bombvars, v)
		subheader("Functions", v)
		addline("CanTopSpin", chaotix.Bomb.CanTopSpin(mo), v)
		addline("CanAct", chaotix.Bomb.CanAct(mo), v)
		subheader("Flags", v)
		addline("MF_BOUNCE", mo.flags & MF_BOUNCE != 0, v)
		addline("PF_JUMPED", player.pflags & PF_JUMPED != 0, v)
		addline("PF_NOJUMPDAMAGE", player.pflags & PF_NOJUMPDAMAGE != 0, v)
		addline("PF_SPINNING", player.pflags & PF_SPINNING != 0, v)
		addline("PF_STARTDASH", player.pflags & PF_STARTDASH != 0, v)
		addline("PF_THOKKED", player.pflags & PF_THOKKED != 0, v)
		addline("PF_SHIELDABILITY", player.pflags & PF_SHIELDABILITY != 0, v)
	end
	if mo and mo.heavyvars
		addheader("Heavy Vars", v)
		addlist(mo.heavyvars, v)
	end
end

hud.add(DebugHUD)