-- fullbright colour, good for overlays
chaotix.SafeFreeslot("SKINCOLOR_FULLBRIGHT")
skincolors[SKINCOLOR_FULLBRIGHT] = {
	name = "Fullbright",
	ramp = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	accessible = false,
}

-- sound mobj specifically to play a single sound
chaotix.SafeFreeslot("MT_CHAOTIX_SOUNDMOBJ")
mobjinfo[MT_CHAOTIX_SOUNDMOBJ] = {
	spawnstate = S_INVISIBLE,
	deathstate = S_NULL,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT,
}
addHook("MobjThinker", function(mo)
	if not (mo.soundplaying) then P_RemoveMobj(mo) return end
	if not (S_SoundPlaying(mo, mo.soundplaying)) then P_RemoveMobj(mo) return end
end, MT_CHAOTIX_SOUNDMOBJ)
chaotix.SpawnSoundMobj = function(mo, sound)
	local soundmo = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_CHAOTIX_SOUNDMOBJ)
	soundmo.soundplaying = sound
	S_StartSound(soundmo, sound)
	return soundmo
end

-- speed trail object (sprite is also used for title screen spotlight)
chaotix.SafeFreeslot("SPR_CXTS", "S_CHAOTIX_SPEEDTRAIL")
local fuse = TICRATE/4
A_ChaotixSpeedTrail = function(mo)
	if not mo.fuse then mo.fuse = fuse end
	local scale = ease.outsine(FRACUNIT*mo.fuse/fuse, FRACUNIT)
	mo.spritexscale = scale + FixedMul(FRACUNIT - scale, abs(sin(mo.rollangle)))
	mo.spriteyscale = scale + FixedMul(FRACUNIT - scale, abs(cos(mo.rollangle)))
end
states[S_CHAOTIX_SPEEDTRAIL] = {SPR_CXTS, A|FF_PAPERSPRITE, 1, A_ChaotixSpeedTrail, 0, 0, S_CHAOTIX_SPEEDTRAIL}

-- Xmomentum support
chaotix.SafeFreeslot("SPR2_SHIT")
spr2defaults[SPR2_SHIT] = SPR2_PAIN

-- smart tether support
chaotix.SafeFreeslot("SPR2_HOLD")
spr2defaults[SPR2_HOLD] = SPR2_EDGE

-- srb2p support
-- ...better to use one of the TALx SPR2s rather than make a new one for this.
-- chaotix.SafeFreeslot("SPR2_PSMN")	-- have these in SPR2, actually
-- spr2defaults[SPR2_PSMN] = SPR2_STND