-- ringslinger neo loadouts
local rsneo_loaded = false
chaotix.RingslingerNEO = function()
	if (rsneo_loaded) then return end	-- already loaded
	if not (RingSlinger) then return end	-- ringslinger neo not added
	
	-- Genji from Overwatch, yeah thats what this loadout is really based on
	RingSlinger.Skins["espio"] = {
		ammo = 30,
		weapons = {RSWPN_BURST, RSWPN_ACCEL}
	}
	
	-- Might honestly be the only normal loadout lol
	RingSlinger.Skins["mighty"] = {
		ammo = 40,
		weapons = {RSWPN_STONE, RSWPN_BURST}
	}
	
	-- Unhinged Beast from the 9th circle of hell
	RingSlinger.Skins["charmy"] = {
	-- 6 scatters, 3 infinities
		ammo = 35,
		weapons = {RSWPN_SCATTER, RSWPN_INFINITY}
	}
	
	-- Splash Synergizes well with his Kit, He might want a replacement for the bounce ring though. lmao outdated comments
	RingSlinger.Skins["vector"] = {
		ammo = 45,
		weapons = {RSWPN_SPLASH, RSWPN_RAIL}
	}
	
	-- Same with Bomb although this time its the secondary, Flash should suffice though.
	RingSlinger.Skins["heavy"] = {
		ammo = 150,
		weapons = {RSWPN_AUTOMATIC, RSWPN_SCATTER}
	}
	
	-- I really can't think of A primary that isn't a lame ass grenade, of course i was going to give him the Explosion ring though
	RingSlinger.Skins["bomb"] = {
		ammo = 40,
		weapons = {RSWPN_EXPLOSION, RSWPN_GRENADE}
	}
	
	-- prevent loading again
	rsneo_loaded = true
end

-- kirby support (i wish there were constants...)
if not (kirbyabilitytable)
    rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable["espio"] = 7	-- tornado
kirbyabilitytable["mighty"] = 3	-- stone
kirbyabilitytable["needle"] = 6	-- needle
kirbyabilitytable["vector"] = 8	-- wheel
kirbyabilitytable["bomb"] = 4	-- bomb

local kirby_loaded = false
chaotix.KirbySupport = function()
	if (kirby_loaded) then return end	-- already loaded
	if not (K_AddAbility) then return end	-- kirby's not added!
	
	-- some basic ability definitions (wish there were constants...)
	kirbyabilitytable["espio"] = 7	-- tornado
	kirbyabilitytable["mighty"] = 3	-- stone
	kirbyabilitytable["needle"] = 6	-- needle
	kirbyabilitytable["vector"] = 8	-- wheel
	kirbyabilitytable["bomb"] = 4	-- bomb
	
	-- heavy gets some special treatment
	local sparklecolors = {}
	sparklecolors[0] = SKINCOLOR_BONE
	sparklecolors[1] = SKINCOLOR_SILVER
	sparklecolors[2] = SKINCOLOR_GREY
	local nspc = 3
	local function RandomOff(num)
		return (P_RandomByte()%num)-(num/2)
	end
	local function SpawnSparkles(mobj, spriteheight)
		local stype = MT_BALLSPARKLE
		local zoff = 8*mobj.scale*P_MobjFlip(mobj)
		local sparkle = P_SpawnMobj(mobj.x+(RandomOff(30)*mobj.scale), mobj.y+(RandomOff(30)*mobj.scale), mobj.z+(mobj.height/2)+(RandomOff(spriteheight)*mobj.scale)+zoff, stype)
		sparkle.scale = mobj.scale
		if(mobj.eflags & MFE_VERTICALFLIP)
			sparkle.eflags = $1|MFE_VERTICALFLIP
		end
		sparkle.color = sparklecolors[P_RandomByte()%nspc]
	end

	local st_none = 0
	local st_activating = 1	-- going TO metal state
	local st_metal = 2
	local st_deactivating = 3	-- going FROM metal state
		
	local kirby_metal = function(checkflags, destroy, late, p)
		local mo = p.mo
		
		-- checking ability flags
		if (checkflags)
			if (p.kvars["ablstate"] == st_activating)
			or (p.kvars["ablstate"] == st_deactivating)
				-- currently transforming
				local flags = AF_NODUCK|AF_NOSWIM|AF_NODROP
				if (p.kvars["ablstate"] == st_activating)
					-- if going TO metal
					flags = $|AF_NOFLOAT|AF_NOJUMP
				end
				
				return flags
			elseif (p.kvars["ablstate"] == st_metal)
				-- currently metal
				return AF_NODUCK|AF_NODROP|AF_WALKSWIM
			end
			
			return 0
		end
		
		-- ability was dropped
		if (destroy)
			-- reset flags
			if (p.kvars["ablstate"] == st_activating)
			or (p.kvars["ablstate"] == st_metal)
				p.pflags = $|(PF_NOJUMPDAMAGE)
				p.charflags = $ & ~(SF_STOMPDAMAGE)
				mo.flags = $|(MF_SHOOTABLE)
			end
			
			return
		end
		
		-- late thinker
		if (late)
			-- change kirby's colour to be metallic!
			if (p.kvars["ablstate"])
				if not (p.kvars["ablstate"] == st_metal)
				and (leveltime%3)
					-- transforming
					return
				end
				
				mo.color = SKINCOLOR_GREY
				mo.colorized = true
			end
			
			return
		end
		
		-- toggle state?
		if (p.cmd.buttons & BT_SPIN)
		and not (p.lastbuttons & BT_SPIN)
			if not (p.kvars["ducking"])
			and not (p.kvars["floating"])
			and not (p.exiting)
			and not (p.pflags & PF_STASIS)
			and not (p.kvars["industdevil"])
			and not (p.powers[pw_carry])
			and not (p.kvars["ablvar1"])	-- not in the middle of any transformation
				if (p.kvars["ablstate"] == st_none)
				or (p.kvars["ablstate"] == st_metal)
					-- go to the respective state
					if (p.kvars["ablstate"] == st_none)
						p.kvars["ablstate"] = st_activating
						p.kvars["ablvar1"] = TICRATE/2
						mo.flags = $ & ~(MF_SHOOTABLE)
						S_StartSound(mo, sfx_rock)
					else
						p.kvars["ablstate"] = st_deactivating
						p.kvars["ablvar1"] = TICRATE/3
						S_StartSound(mo, sfx_unrock)
						
						-- reset flags
						p.pflags = $|(PF_NOJUMPDAMAGE)
						p.charflags = $ & ~(SF_STOMPDAMAGE)
						mo.flags = $|(MF_SHOOTABLE)
					end
					
					-- reset these
					p.kvars["ablvar2"] = 0
					p.kvars["ablvar3"] = 0
				end
			end
		end
		
		-- state functions
		if (p.kvars["ablstate"] == st_activating)
		or (p.kvars["ablstate"] == st_deactivating)
			-- suspend in air a bit while transforming
			if (p.kvars["ablstate"] == st_activating)
				-- reduce speed
				local modifier = FRACUNIT*9/10
				mo.momx = FixedMul(modifier, $)
				mo.momy = FixedMul(modifier, $)
				
				-- float up
				p.pflags = $|(PF_JUMPED)
				mo.state = S_PLAY_FALL
				P_SetObjectMomZ(mo, FRACUNIT*2)
			end
			
			-- finish transformation
			p.kvars["ablvar1"] = $ and $-1 or 0
			if not (p.kvars["ablvar1"])
				-- finish transformation
				p.kvars["ablstate"] = (p.kvars["ablstate"] == st_activating) and st_metal or st_none
			else
				-- spawn sparkles like stone would
				SpawnSparkles(mo, 30)
			end
		else
			if (p.kvars["ablstate"] == st_metal)	-- currently transformed
				-- slower speed
				p.normalspeed = FixedMul(FRACUNIT/3, skins[mo.skin].normalspeed)	-- slower speed
				
				-- heavier gravity
				local ghost_add = FixedMul(mo.scale, -(FRACUNIT*10))
				local max_ghosts = 5
				local impact_speed = ghost_add * 2
				
				if not (P_IsObjectOnGround(mo))
					-- increase gravity
					local modifier = FRACUNIT
					mo.momz = $ + (FixedMul(P_GetMobjGravity(mo), modifier))
					
					if not (p.kvars["floating"])
						-- store momz for impact
						local momz = mo.momz * P_MobjFlip(mo)
						if (momz <= impact_speed)
							if not (p.kvars["ablvar2"])
								-- play a sound for falling fast enough
								p.kvars["ablvar2"] = 1
								S_StartSound(mo, sfx_s3k51)
							end
							
							-- break floors
							local rover = mo.floorrover
							
							if (rover and rover.valid)
							and (rover.flags & FF_EXISTS)
							and ((rover.flags & FF_STRONGBUST) or (rover.flags & FF_BUSTUP))
								-- height checks
								local topheight = rover.topheight - mo.momz
								local bottomheight = rover.bottomheight - mo.momz
								
								if not (mo.z >= topheight)
								and not (mo.z + mo.height < bottomheight)
									-- break it if we're here!
									EV_CrumbleChain(rover)
									if (rover.master.flags & ML_EFFECT5)
										P_LinedefExecute(P_AproxDistance(rover.master.dx, rover.master.dy)>>FRACBITS, mo, mo.subsector.sector)
									end
									
									-- kirby sound
									S_StartSound(mo, sfx_stoneb)
								end
							end
						else
							p.kvars["ablvar2"] = 0
						end
						
						-- spawn ghosts
						if (momz < ghost_add)
							momz = $ - ghost_add	-- easier calculations
							
							local g = P_SpawnGhostMobj(mo)
							g.tics = min(max_ghosts, 2 + max(0, momz / ghost_add))
						end
					else
						p.kvars["ablvar2"] = 0
					end
				else
					-- heavy impact?
					if (p.kvars["ablvar2"])
					and not (P_CheckDeathPitCollide(mo))
						local dnum = 0
						local rotnum = 16
						local rotadd = FixedAngle((360*FRACUNIT)/rotnum)
						while(dnum < rotnum)
							-- copypasted from stone
							local dust = P_SPMAngle(mo, MT_KIRBYHAMMERDUST, rotadd*dnum, 0)
							if(dust and dust.valid)
								local mul = ((P_RandomByte()*FRACUNIT/512)+(FRACUNIT))*2
								dust.momx = FixedMul(mul, $1)
								dust.momy = FixedMul(mul, $1)
								dust.momx = $1 + mo.momx
								dust.momy = $1 + mo.momy
								if(mo.eflags & MFE_UNDERWATER)
							//		or(player.mo.eflags & MFE_TOUCHWATER)
									dust.state = S_SPINDUST_BUBBLE1
								end
							end
							dnum = $1 + 1
						end
						S_StartSound(mo, sfx_stone)
					else
						-- landing sound
						if not (p.kvars["prevground"])
							S_StartSound(mo, sfx_stone)
						end
					end
					
					-- reset these
					p.kvars["ablvar2"] = 0
				end
			end
		end
		
		-- walking
		if (p.kvars["ablstate"] == st_metal)
		and (P_IsObjectOnGround(mo))
		and (mo.sprite2 == SPR2_WALK)
			local frame = (mo.frame & FF_FRAMEMASK)
			
			-- walking sounds!
			if (frame == 0 or frame == 4)	-- A and E are the frames
			and not (p.kvars["ablvar3"] == frame)
				S_StartSound(mo, sfx_stone)
			end
			
			-- store frame
			p.kvars["ablvar3"] = (mo.frame & FF_FRAMEMASK)
		else
			p.kvars["ablvar3"] = -1	
		end
		
		-- set player flags
		if (p.kvars["ablstate"] == st_activating)
		or (p.kvars["ablstate"] == st_metal)
			-- dont be damaged like stone
			mo.flags = $ & ~(MF_SHOOTABLE)
			if (P_CheckDeathPitCollide(mo))
				player.mo.flags = $|(MF_SHOOTABLE)
			end
		
			-- allow stomp damage
			if (p.kvars["ablstate"] == st_metal)
				-- allow stomp damage
				p.pflags = $ & ~(PF_NOJUMPDAMAGE)
				p.charflags = $|(SF_STOMPDAMAGE)
			end
		end
	end
	kirbyabilitytable["heavy"] = K_AddAbility(kirby_metal, false, "METAL")	-- add heavy's ability
	
	-- all loaded
	kirby_loaded = true
end

-- add hooks
chaotix.AddHook("ThinkFrame", chaotix.RingslingerNEO)
chaotix.AddHook("ThinkFrame", chaotix.KirbySupport)