//Krabs
local character_frames = {
	//vector
	{19, 20, 21, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18},
	//charmy
	{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26},
	//mighty
	{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18},
	//heavy
	{1, 2, 3, 4, 5, 6, 7, 8},
	//espio
	{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 2, 3, 4, 5, 6, 7, 8, 9, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32},
	//bomb
	{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36},
}
local character_ow = {0, 0, 0, 0, 0, 0}
local character_ow2 = {0, 0, 0, 0, 0, 0}
local character_ow_bomb_fuse = 0
local character_ow_bomb_explosion = 0

//local vars for everything since we don't need to be net synced
local title_phase = 0
local title_phase_tics = 0
local title_anim = 0
local title_anim2 = 0
local title_scale = TITLE_SCALE_START
local title_camera = nil
local title_fadeblack = 0
local title_lives = 0
local title_music = false

//Settings
local TITLE_SCALE_TIME = 58
local TITLE_SCALE_START = FRACUNIT * 8
local TITLE_SCALE_TARGET = FRACUNIT / 7
local TITLE_SCALE_PER_TIC = (TITLE_SCALE_TARGET - TITLE_SCALE_START) / TITLE_SCALE_TIME
local TITLE_BEAM_ANGLE = ANG10 * 4
local TITLE_MAXTIME = INT16_MAX

//Make sure the title screen is active
local function inTitleScreen()
	if gamestate == GS_NULL or gamestate == GS_TITLESCREEN
		return mapheaderinfo[titlemap].chaotixtitle
	elseif gamestate == GS_LEVEL
		return mapheaderinfo[gamemap].chaotixtitle and leveltime
	end
end

//Main title screen logic
chaotix.AddHook("ThinkFrame", do
	if not inTitleScreen() or title_phase == nil
		title_phase = 0
		title_phase_tics = 0
		title_fadeblack = 0
		title_anim = 0
		title_anim2 = 0
		title_scale = TITLE_SCALE_START
		title_music = false
		title_camera = nil
		
		if title_lives == 1
			hud.enable("lives")
		end
		title_lives = 0
		return
	end
	title_music = S_MusicPlaying() and not S_MusicPaused() and S_MusicName() == "chaotx"
	and CV_FindVar("digimusic").value and not CV_FindVar("musicpref").value
	
	if gamestate == GS_LEVEL and not title_lives
		if hud.enabled("lives")
			hud.disable("lives")
			title_lives = 1
		else
			title_lives = 2
		end
	end
	
	title_anim2 = max($ + 1, 1)
	if not (title_camera and title_camera.valid)
		for mo in mobjs.iterate()
			if (gamestate == GS_TITLESCREEN and mo.type == MT_ALTVIEWMAN)
			or (gamestate == GS_LEVEL and mo.type == MT_TUBEWAYPOINT)
				title_camera = mo
			end
		end
		return
	end
	if title_phase == 0
		if title_phase_tics >= 20
			S_ChangeMusic("chaotx", true)
			title_phase = $ + 1
			title_phase_tics = 0
		elseif not title_phase_tics
			local spawn = title_camera.spawnpoint
			P_SetOrigin(title_camera, spawn.x*FRACUNIT, spawn.y*FRACUNIT, spawn.z*FRACUNIT)
		end
	elseif title_phase == 1
		if title_phase_tics % 4 == 0
			title_fadeblack = min(10, $ + 1)
		end
		title_scale = max(FRACUNIT/7, $ + TITLE_SCALE_PER_TIC)
		
		if title_scale == FRACUNIT/7
			title_phase = $ + 1
			title_phase_tics = 0
		else
			local speed = (1 + title_phase_tics) * FRACUNIT * 2
			P_MoveOrigin(title_camera, title_camera.x - speed, title_camera.y, title_camera.z)
		end
	elseif title_phase == 2
		title_anim = max($ + 1, 1)
	end
	title_phase_tics = max($ + 1, 1)
end)

//Stops O__TITLE from playing
chaotix.AddHook("MusicChange", function(oldname, newname, mflags, looping, position, prefadems, fadeinms)
	if newname == "_title" and inTitleScreen()
		if title_phase
			S_ChangeMusic("chaotx", true)
		end
		return true
	end
end)

//Let you play the level normally??
chaotix.AddHook("PlayerThink", function(player)
	if not mapheaderinfo[gamemap].chaotixtitle then return end
	if title_camera and title_camera.valid
		player.awayviewmobj = title_camera
		player.awayviewtics = -1
	end
	
	player.powers[pw_nocontrol] = -1
	player.pflags = $ | PF_FULLSTASIS
	if player.mo then player.mo.renderflags = $ | RF_FULLBRIGHT end
end)

//Funny
local bully = function(num)
	if num == 4
		character_ow[num] = $ + 7
		S_StartSound(nil, sfx_s3k49)
	else
		character_ow[num] = $ + 18
		S_StartSoundAtVolume(nil, sfx_kc3b, 200)
	end
	character_ow2[num] = 28
end

chaotix.AddHook("KeyDown", function(keyevent)
	if not inTitleScreen() return end
	if character_ow_bomb_explosion > 0 return true end
	if title_phase < 2 return end
	if keyevent.name == 'v'
		bully(1)
		return true
	elseif keyevent.name == 'c'
		bully(2)
		return true
	elseif keyevent.name == 'm'
		bully(3)
		return true
	elseif keyevent.name == 'h'
		bully(4)
		return true
	elseif keyevent.name == 'e'
		bully(5)
		return true
	elseif keyevent.name == 'b'
		bully(6)
		character_ow_bomb_fuse = $ + 10
		if (character_ow_bomb_fuse >= 200)
			character_ow_bomb_explosion = 1
			S_StartSoundAtVolume(nil, sfx_kc36, 85)
			S_StopMusic(consoleplayer)
		end
		return true
	end
end)

chaotix.AddHook("ThinkFrame", function(keyevent)
	for i = 1, 6
		if character_ow[i] > 0
			character_ow[i] = max(0,  $ - 1 - (character_ow[i] / 4))
		end
		if character_ow2[i] > 0
			character_ow2[i] = max(0,  $ - 1)
		end
	end
	if character_ow_bomb_explosion > 0
		character_ow[6] = character_ow_bomb_explosion / 2
		character_ow_bomb_explosion = $ + 1
		if character_ow_bomb_explosion == 30
			S_StartSound(nil, sfx_kc3b)
			S_StartSound(nil, sfx_kc41)
			S_StartSound(nil, sfx_bkpoof)
			S_StartSound(nil, sfx_bkpoof)
		end
		if character_ow_bomb_explosion >= 90
			COM_BufInsertText(consoleplayer, "quit")
		end
	elseif character_ow_bomb_fuse > 0
		character_ow_bomb_fuse = $ - 1
	end
end)

//Helper functions for drawing character frames
local function getFrameName(name, frame)
	if frame == nil
		return name+"01"
	elseif frame < 10
		return name+"0"+tostring(frame)
	end
	return name+tostring(frame)
end
local function drawCharacter(v, x, y, name, character, shadow_scale, shadow_x, shadow_y, framerate_denominator, framerate_numerator, frame_override)
	y = $ + 108
	local scale = 7 * title_scale
	local frame
	if character_ow2[character] > 0 or character_ow_bomb_explosion
		if character == 6 and (character_ow_bomb_explosion > 1) and (title_anim2 % 2)
			frame = name + "EX"
		else
			frame = name + "OW"
		end
	else
		if frame_override != nil
			frame = frame_override
		else
			frame = ((title_anim * framerate_denominator / framerate_numerator) % #character_frames[character]) + 1
		end
		frame = getFrameName(name, character_frames[character][frame])
	end
	x = (160 * FRACUNIT) + ($ * scale)
	y = (100 * FRACUNIT) + ($ * scale)
	if shadow_scale
		v.drawStretched(x + (shadow_x * scale), y + (shadow_y * scale), FixedMul(shadow_scale, title_scale * 3), FixedMul(shadow_scale, title_scale), v.cachePatch("CHSHADOW"), V_60TRANS)
	end
	local flip = 1
	if title_anim2 % 2
		flip = -1
	end
	if character == 6 and character_ow_bomb_explosion > 0
		local trans = V_70TRANS
		if title_anim2 % 2
			trans = V_50TRANS
		end
		local sc = character_ow_bomb_explosion * FRACUNIT/20
		v.drawStretched(x, y - 10*scale, sc, sc, v.cachePatch("CHBOOM"), trans)
	end
	v.drawScaled(x - character_ow[character] * scale * flip, y, title_scale, v.cachePatch(frame))
end

local sparkframe = 0
local music_offset = 6*5
local bpm = 140

local function drawTitle(v)
	if not inTitleScreen() then return end
	
	//Black bar to cover up the score and such
	if gamestate == GS_LEVEL
		v.drawFill(0, 0, v.width(), 98, 31 | V_SNAPTOLEFT)
	end
	
	//City
	local beam_angle = TITLE_BEAM_ANGLE + (sin(title_anim2 * ANG1*3) * 2000)
	local beam_flags = V_ADD
	if title_anim2 % 2
		beam_flags = $ | V_40TRANS
	else
		beam_flags = $ | V_10TRANS
	end
	v.drawScaled(160 * FRACUNIT, 98 * FRACUNIT, FRACUNIT*3/4, v.cachePatch("NEWTRGC2"))
	v.drawScaled(160 * FRACUNIT, 38 * FRACUNIT, FRACUNIT*3/4, v.getSpritePatch(SPR_CXTS, B, 0, beam_angle), beam_flags)
	v.drawScaled(173 * FRACUNIT, 48 * FRACUNIT, FRACUNIT*3/4, v.getSpritePatch(SPR_CXTS, B, 0, -beam_angle), beam_flags)
	v.drawScaled(160 * FRACUNIT, 98 * FRACUNIT, FRACUNIT*3/4, v.cachePatch("NEWTRGC1"))
	
	//Foreground elements
	if title_phase != 0
		local position = title_anim
		if title_music
			position = S_GetMusicPosition()*TICRATE/MUSICRATE
		end
		
		local music_speed = (TICRATE*60)/bpm
		local inbetween = music_speed / 10
		local music_anim = (position + music_offset) % (music_speed*2)
		local music_anim2 = (position + music_offset) % (music_speed*4)
		
		//Sign
		local sign_patch = "CHTXSIG3"
		if music_anim < inbetween or music_anim > music_speed and music_anim <= music_speed + inbetween
			sign_patch = "CHTXSIG2"
		elseif music_anim > music_speed + inbetween
			sign_patch = "CHTXSIG1"
		end
		
		//Logo
		local logo_frame = getFrameName("CHXLOG", ((title_anim / 3) % 22) + 1)
		v.drawScaled(160 * FRACUNIT, 100 * FRACUNIT, title_scale, v.cachePatch(sign_patch))
		v.drawScaled(160 * FRACUNIT, 100 * FRACUNIT, title_scale, v.cachePatch(logo_frame))
		local anim2_fade = 1 - (music_anim2*8/music_speed)
		local anim2_fade2 = 0
		if (anim2_fade >= 0)
			anim2_fade2 = TR_TRANS90 - (anim2_fade*TR_TRANS10)
			v.drawScaled(160 * FRACUNIT, 100 * FRACUNIT, title_scale, v.cachePatch(logo_frame), anim2_fade2, v.getColormap(TC_ALLWHITE, 0))
		end
		
		//Lads
		if gamestate == GS_TITLESCREEN
			local vector_frame
			local mighty_frame
			if title_music
				music_speed = (TICRATE*FRACUNIT*60)/bpm
				local music_anim3 = ((position + music_offset) * FRACUNIT) % (music_speed*3)
				vector_frame = 1 + (FixedDiv(music_anim3, music_speed*3) * 21/FRACUNIT)
				//mighty_frame = 1 + (FixedDiv(music_anim3, music_speed*3) * 17/FRACUNIT)
			end
			
			drawCharacter(v, -44, -15, "VECTOR", 1,       FRACUNIT, -3, -12, 2, 5, vector_frame)
			drawCharacter(v,  65, -94, "CHARMY", 2,              0,  0,   0, 2, 5)
			drawCharacter(v,  50, -18, "MIGHTY", 3, FRACUNIT * 4/5, -1,  -5, 1, 3, mighty_frame)
			drawCharacter(v, -92,  -5, "HEAVY_", 4,       FRACUNIT, -5,  -5, 2, 5)
			drawCharacter(v,  -6,  -1, "ESPIO_", 5, FRACUNIT * 5/6,  3, -10, 1, 3)
			drawCharacter(v,  96,  -7, "BOMB__", 6, FRACUNIT * 2/3, -2,  -6, 2, 5)
		end
	end
	
	//Black screen fade
	if title_fadeblack != 10
		v.drawStretched(-32 * FRACUNIT, -8 * FRACUNIT, 600 * FRACUNIT, 400 * FRACUNIT, v.cachePatch("CH_BFILL"), title_fadeblack * V_10TRANS)
	end
	
	if character_ow_bomb_explosion >= 30
		local fade = character_ow_bomb_explosion - 29
		if fade < 10
			fade = (10 - fade) * V_10TRANS
		else
			fade = 0
		end
		v.drawStretched(-32 * FRACUNIT, -8 * FRACUNIT, 600 * FRACUNIT, 400 * FRACUNIT, v.cachePatch("CH_WFILL"), fade * V_10TRANS)
	end
end

hud.add(drawTitle)
hud.add(drawTitle, "title")