-- the lua directory
local directories = {
	-- general files
	{
		//folder = "",	-- no folder, it's the root
		files = {
			"ChaotixMain",
			"ChaotixSOC",
			"commandqueue",
			"ChaotixSupport",
			"ChaotixConfig",
			"ChaotixTitle",
			"CBW_Debug",
		},
	},
	
	-- espio's lua files
	{
		folder = "1_Espio",
		files = {
			"espio_defs",
			"espio_animations",
			"espio_battle",
			"espio_drillspin",
			"espio_teleport",
			"espio_wallrun",
			"espio_ceilingcling",
			"espio_shield",
			"espio_persona",
			"espio_colourshift",
			"espio_hooks",
		},
	},
		
	-- mighty's lua files
	{
		folder = "2_Mighty",
		files = {
			"mighty_defs",
			"mighty_teeter",
			"mighty_battle",
			"mighty_wallkick",
			"mighty_hammerdrop",
			"mighty_protectiondefs",
			"mighty_protection",
			"mighty_memes",
			"mighty_hooks",
		},
	},
	
	-- charmy's lua files
	{
		folder = "3_Charmy",
		files = {
			"charmy_defs",
			"charmy_scale",
			"charmy_battle",
			"charmy_knockback",
			"charmy_slowfall",
			"charmy_quickascent",
			"charmy_stinger",
			"charmy_wings",
			"charmy_coop",
			"charmy_hooks",
		},
	},
	
	-- vector's lua files
	{
		folder = "4_Vector",
		files = {
			"vector_defs",
			"vector_extras",
			"vector_battle",
			"vector_recordrush",
			"vector_beatbash",
			"vector_hooks",
		},
	},
	
	-- heavy's lua files
	{
		folder = "5_Heavy",
		files = {
			"heavy_soc",
			"heavy_defs",
			"heavy_abilities",
			"heavy_battle",
		},
	},
	
	-- bomb's lua files
	{
		folder = "6_Bomb",
		files = {
			"bomb_defs",
			"bomb_battle",
			"bomb_thokked",
			"bomb_explode",
			"bomb_fuseshot",
			"bomb_fusedash",
			"bomb_topspin",
			"bomb_volatile",
			"bomb_cupcake",
			"bomb_hooks",
		},
	},
}
-- load the files
for _, directory in ipairs(directories)
	local folder = directory.folder
	for _, file in ipairs(directory.files)
		local path = file
		if (folder) then path = folder.."/"..$..".lua" end
		dofile(path)
	end
end